# (tmb) gcc-10.1 build hangs with mulithreaded rpmbuild
%global _smp_nthreads_max 1

# used for easy branding
%define distro			mageia

%define branch			10
%define branch_major		3
%define branch_minor		0
%define rel			1
%define branch_tag		%(perl -e 'printf "%%02d%%02d", split(/\\./,shift)' %{branch})
%define snapshot		%nil
%define rc_build		%nil
%define nof_arches		noarch
%define biarches		x86_64

# Define libraries major versions
%define libcc_major		0
%define libgcc_major		1
%define libstdcxx_major		6
%define libstdcxx_micro		28
%define libgfortran_major	5
%define libobjc_major		4
%define libgnat_major		10
%define libffi_major		4
%define libssp_major		0
%define libgomp_major		1
%define libquadmath_major	0
%define libgphobos_major	1
%define libitm_major		1
%define libasan_major		6
%define libatomic_major		1
%define libatomic_minor		2
%define liblsan_major		0
%define libtsan_major		0
%define libubsan_major		1
%define libvtv_major		0

# Disable -Werror because there's a format string warning in gcc/cp/parser.c 
# around line 2300 that a comment says is intentional :( 
%define Werror_cflags %nil

# Define if building a cross compiler
# FIXME: assume user does not define both cross and cross_bootstrap variables
%define build_cross		0
%define build_cross_bootstrap	0
%{expand: %{?cross:		%%global build_cross 1}}
%{expand: %{?cross_bootstrap:	%%global build_cross_bootstrap 1}}

# System compiler in Mageia
%define system_compiler		1

%define target_cpu		%{_target_cpu}
%if %{build_cross}
%define system_compiler		0
%define target_cpu		%{cross}
%endif
%if %{build_cross_bootstrap}
%define build_cross		1
%define system_compiler		0
%define target_cpu		%{cross_bootstrap}
%endif
%if %{system_compiler}
%define alternative_priority	30%{branch_tag}
%define cross_prefix		%{nil}
%define cross_program_prefix	%{nil}
%define package_suffix		%{nil}
%define program_prefix		%{nil}
%define program_suffix		%{nil}
%define program_long_suffix     -%{branch}
%else
%if %{build_cross}
%define alternative_priority	10%{branch_tag}
%define cross_prefix		cross-%{target_cpu}-
%define cross_program_prefix	%{target_cpu}-%{_real_vendor}-linux%{gnuext}-
%define package_suffix		%{nil}
%define program_prefix		%{cross_program_prefix}
%define program_suffix		%{nil}
%define program_long_suffix	-%{branch}
%else
%define alternative_priority	20%{branch_tag}
%define cross_prefix		%{nil}
%define cross_program_prefix	%{nil}
%define package_suffix		%{branch}
%define program_prefix		%{nil}
%define program_suffix		%{branch}
%define program_long_suffix	%{branch}
%endif
%endif
%define _alternativesdir	/etc/alternatives
%if "%{package_suffix}" == "%{nil}"
%define _package_suffix		%{nil}
%else
%define _package_suffix		-%{package_suffix}
%endif

%if "%snapshot" != ""
%if "%rc_build" != ""
%define source_package		gcc-%{version}-RC-%{snapshot}
%define source_dir		gcc-%{version}-RC-%{snapshot}
%else
%define source_package		gcc-%{branch}-%{snapshot}
%define source_dir		gcc-%{branch}-%{snapshot}
%endif
%else
%define source_package		gcc-%{version}
%define source_dir		gcc-%{version}
%endif

# Define GCC target platform, and arch we built for
%if %{build_cross}
%define biarches		noarch
%define arch			%{target_cpu}
%define gcc_target_platform	%{target_cpu}-%{_real_vendor}-linux%{gnuext}
%define target_prefix		%{_prefix}/%{gcc_target_platform}
%define target_libdir		%{target_prefix}/%{target_lib}
%define target_slibdir		%{target_prefix}/%{target_lib}
%define target_slibdir32	%{target_prefix}/lib
%else
%define arch			%(echo %{_target_cpu}|sed -e "s/\\(i.86\\|athlon\\)/i386/" -e "s/amd64/x86_64/")
%define gcc_target_platform	%{_target_platform}
%define target_prefix		%{_prefix}
%define target_libdir		%{_libdir}
%define target_slibdir		/%{_lib}
%define target_slibdir32	/lib
%endif
%define isarch()		%(case " %* " in (*" %{arch} "*) echo 1;; (*) echo 0;; esac)
%define gcc_libdir		%{_prefix}/lib/gcc

%if %{build_cross}
%if %isarch %arm
%define gnuext			-gnueabi
%else
%define gnuext			-gnu
%endif
%endif

%if %isarch x86_64 aarch64
%define target_lib		lib64
%else
%define target_lib		lib
%endif

%if %isarch x86_64
%define multilib_32_arch	i586
%endif
%if %isarch %{biarches}
%define gcc32_target_platform	%{multilib_32_arch}-%{distro}-%{_target_os}%{?_gnu}
%endif

# We now have versioned libstdcxx_includedir, that is c++/<VERSION>/
%define libstdcxx_includedir	%{target_prefix}/include/c++/%{branch}

%define build_minimal		0
%define build_monolithic	0
%define build_doc		1
%define build_pdf_doc		0
%define build_libstdcxx_docs	1
%define build_check		0
%define build_ada		1
%define build_d			1
%define build_cxx		1
%define build_libstdcxx		%{build_cxx}
%define build_fortran		1
%if %isarch %arm aarch64
%define build_quadmath		0
%else
%define build_quadmath		1
%endif
%define build_objc		1
%define build_objc_gc		0
%define build_objcp		1
%define build_libffi		0
%define build_libgomp		1
%define build_debug		0
%define build_stdcxxheaders	1
%define build_libitm		1
%define build_libasan		1
%define build_libatomic		1
%define build_libubsan		1
# only i?86 and x86_64 are supported, see libvtv/configure.tgt
%ifarch %{ix86} x86_64
%define build_libvtv		0
%else
%define build_libvtv		0
%endif
%if %isarch x86_64 aarch64
%define build_liblsan		1
%define build_libtsan		1
%else
%define build_liblsan		0
%define build_libtsan		0
%endif
# use SSP support from glibc
%define use_ssp_glibc		1
%define build_libssp		0
%if !%{system_compiler}
%define build_objc		0
%define build_objc_gc		0
%define build_objcp		0
%define build_ada		0
%define build_libffi		0
%define build_libgomp		0
%endif
%define build_isl		1

# Define C library to use
%define libc glibc
%define libc_shared 1
%if !%{build_cross_bootstrap}
# Make sure pthread.h doesn't contain __thread keyword
%define libc_version 		2.2.5-14
%if %{use_ssp_glibc}
# Make sure glibc supports stack protector
%define libc_version 		2.4-1
%endif
%endif

# Allow --with[out] <feature> at rpm command line build
%{expand: %{?_without_PDF:	%%global build_pdf_doc 0}}
%{expand: %{?_without_DEBUG:	%%global build_debug 0}}
%{expand: %{?_without_check:	%%global build_check 0}}
%{expand: %{?_without_CHECK:	%%global build_check 0}}
%{expand: %{?_without_MINIMAL:	%%global build_minimal 0}}
%{expand: %{?_with_PDF:		%%global build_pdf_doc 1}}
%{expand: %{?_with_DEBUG:	%%global build_debug 1}}
%{expand: %{?_with_CHECK:	%%global build_check 1}}
%{expand: %{?_with_MINIMAL:	%%global build_minimal 1}}

# Allow --without <front-end> at rpm command line build
%{expand: %{?_with_CXX:		%%global build_cxx 1}}
%{expand: %{?_with_ADA:		%%global build_ada 1}}
%{expand: %{?_with_FORTRAN:	%%global build_fortran 1}}
%{expand: %{?_with_OBJC:	%%global build_objc 1}}
%{expand: %{?_with_OBJCXX:	%%global build_objcp 1}}
%{expand: %{?_with_D:		%%global build_d 1}}

# Allow --with <front-end> at rpm command line build
%{expand: %{?_without_CXX:	%%global build_cxx 0}}
%{expand: %{?_without_ADA:	%%global build_ada 0}}
%{expand: %{?_without_FORTRAN:	%%global build_fortran 0}}
%{expand: %{?_without_OBJC:	%%global build_objc 0}}
%{expand: %{?_without_OBJCXX:	%%global build_objcp 0}}
%{expand: %{?_without_D:	%%global build_d 0}}

# A minimal build overrides all other options
%if %{build_cross_bootstrap}
%define build_minimal		1
%define libc_shared		0
%endif
%if %{build_minimal}
%define build_doc		0
%define build_pdf_doc		0
%define build_libstdcxx_docs	0
%define build_check		0
%define build_ada		0
%define build_cxx		0
%define build_fortran		0
%define build_quadmath		0
%define build_objc		0
%define build_objc_gc		0
%define build_objcp		0
%define build_d			0
%define build_debug		0
%define build_libffi		0
%define build_libitm		0
%define build_libasan		0
%define build_libatomic		0
%define build_liblsan		0
%define build_libtsan		0
%define build_libubsan		0
%endif
%if %{build_cross}
%define build_monolithic	1
%define build_doc		0
%define build_pdf_doc		0
%define build_libstdcxx_docs	0
# Unsupported front-ends when cross-compiling for now
%define build_check		0
%define build_ada		0
%define build_libffi		0
%endif

# Define library packages names
%define libgcc_name_orig	%{cross_prefix}libgcc
%define libgcc_name		%{libgcc_name_orig}%{libgcc_major}
%define libstdcxx_name_orig	%{cross_prefix}libstdc++
%define libstdcxx_name		%{libstdcxx_name_orig}%{libstdcxx_major}
%define libgfortran_name_orig	%{cross_prefix}libgfortran
%define libgfortran_name	%{libgfortran_name_orig}%{libgfortran_major}
%define libgphobos_name_orig	%{cross_prefix}libgphobos
%define libgphobos_name		%{libgphobos_name_orig}%{libgphobos_major}
%define libobjc_name_orig	%{cross_prefix}libobjc
%define libobjc_name		%{libobjc_name_orig}%{libobjc_major}
%define libgnat_name_orig	%{cross_prefix}libgnat
%define libgnat_name		%{libgnat_name_orig}%{libgnat_major}
%define libffi_name_orig	%{cross_prefix}libffi
%define libffi_name		%{libffi_name_orig}%{libffi_major}
%define libssp_name_orig	%{cross_prefix}libssp
%define libssp_name		%{libssp_name_orig}%{libssp_major}
%define libgomp_name_orig	%{cross_prefix}libgomp
%define libgomp_name		%{libgomp_name_orig}%{libgomp_major}
%define libquadmath_name_orig	%{cross_prefix}libquadmath
%define libquadmath_name	%{libquadmath_name_orig}%{libquadmath_major}
%define libitm_name_orig	%{cross_prefix}libitm
%define libitm_name		%{libitm_name_orig}%{libitm_major}
%define libasan_name_orig	%{cross_prefix}libasan
%define libasan_name		%{libasan_name_orig}%{libasan_major}
%define libatomic_name_orig	%{cross_prefix}libatomic
%define libatomic_name		%{libatomic_name_orig}%{libatomic_major}
%define liblsan_name_orig	%{cross_prefix}liblsan
%define liblsan_name		%{liblsan_name_orig}%{liblsan_major}
%define libtsan_name_orig	%{cross_prefix}libtsan
%define libtsan_name		%{libtsan_name_orig}%{libtsan_major}
%define libubsan_name_orig	%{cross_prefix}libubsan
%define libubsan_name		%{libubsan_name_orig}%{libubsan_major}
%define libvtv_name_orig	%{cross_prefix}libvtv
%define libvtv_name		%{libvtv_name_orig}%{libvtv_major}

# Extract Mageia name and version
%define mga_distro_version_file	/etc/release
%define mga_distro_version	%(perl -ne '/^([.\\w\\s]+) \\(.+\\).+/ and print $1' < %{mga_distro_version_file})

Summary:	GNU Compiler Collection
Name:		%{cross_prefix}gcc%{package_suffix}
Version:	%{branch}.%{branch_major}.%{branch_minor}
%if "%snapshot" != ""
%if "%rc_build" != ""
Release:	%mkrel 0.RC.%{rel}
%else
Release:	%mkrel 0.%{snapshot}.%{rel}
%endif
%else
Release:	%mkrel %{rel}
%endif
License:	GPLv3+
Group:		Development/C

# Main source:	
URL:		https://gcc.gnu.org/
%if "%snapshot" != ""
%if "%rc_build" != ""
Source0:	ftp://gcc.gnu.org/pub/gcc/snapshots/%{version}-RC-%{snapshot}/%{source_package}.tar.xz
%else
Source0:	https://gcc.gnu.org/pub/gcc/snapshots/%{branch}-%{snapshot}/%{source_package}.tar.xz
%endif
%else
Source0:	https://ftpmirror.gnu.org/gcc/%{source_package}/%{source_package}.tar.xz
%endif

# Patches
# upstream gcc-10 branch, numbered from 1

# upstream master branch, numbered from 101

# Mageia patches, numbered from 201
# build 32 bits code when running through linux32
Patch201:	gcc-10.1-linux32.patch
# slibdir is either /lib or /lib64
Patch202:	gcc-10.1-pass-slibdir.patch
# pass libdir around
Patch203:	gcc-10.1-multi-do-libdir.patch

# Fedora patches, numbered from 501

# Want updated alternatives priorities
%if %{build_cross}
Conflicts:	gcc-cpp < 3.2.2-4
%endif
# TEMP FORCE NEW binutils
%define binutils_version 1:2.35.2-1

# libmudflap got dropped in upstream 4.9
Obsoletes:	libmudflap0
Obsoletes:	libmudflap-devel
# libcilkrts got dropped in upstream 8.0
Obsoletes:	libcilkrts5
Obsoletes:	libcilkrts-devel

# switch to python3
BuildRequires:  python3

Requires:	%{cross_prefix}binutils >= %{binutils_version}
BuildRequires:	%{cross_prefix}binutils >= %{binutils_version}
# c++ is mandatory to build gcc
BuildRequires:	gcc >= 10.1.0-1
BuildRequires:	gcc-c++ >= 10.1.0-1
# Make sure gdb will understand DW_FORM_strp
Conflicts:	gdb < 5.1.1
BuildRequires:	zlib-devel
# Zstd LTO Bytecode Compression Support
BuildRequires:	zstd-devel
BuildRequires:	chrpath

%if %{build_ada}
# Ada requires Ada to build
BuildRequires:	%{name}10-gnat >= 10.1.0-1
%endif
# isl is used for Graphite support (optimizations)
# see http://gcc.gnu.org/wiki/Graphite
%if %{build_isl}
BuildRequires:	isl-devel >= 0.14
%endif
#needed for lto support
BuildRequires:	elfutils-devel
Requires:	%{name}-cpp = %{version}-%{release}
# FIXME: We need a libgcc with 3.4 symbols
%if %{libc_shared} && !%{build_monolithic}
Requires:	%{libgcc_name_orig} >= 3.3.2-5
%endif
Requires(post): update-alternatives
Requires(postun): update-alternatives
BuildRequires:	gettext
BuildRequires:	flex
BuildRequires:	bison
BuildRequires:	texinfo >= 4.1
BuildRequires:	texinfo-tex
# XXX: Needs a GNU awk recent enough to correctly generate options.h
BuildRequires:	gawk >= 3.1.4
%if "%{?libc_version:%{libc_version}}" != ""
Requires:	%{cross_prefix}%{libc}-devel >= %{libc_version}
BuildRequires:	%{cross_prefix}%{libc}-devel >= %{libc_version}
%endif
%if %{build_check}
BuildRequires:	%{cross_prefix}glibc-static-devel
BuildRequires:	autogen
%endif
%if %{system_compiler}
Obsoletes:	gcc%{branch}
Provides:	gcc%{branch} = %{version}-%{release}
# see later warning about libgcc_so & ld script
# rpm has not way to find that ld script is ld script
%if !%build_cross
%if %isarch %{arm} %{ix86} x86_64
Provides:	devel(libgcc_s)
%endif
%if %isarch x86_64 aarch64
Provides:	devel(libgcc_s(64bit))
%endif
%endif
%else
Conflicts:	%{cross_prefix}gcc%{branch} < %{version}-%{release}
%endif
%if %{build_pdf_doc}
BuildRequires:	tetex
BuildRequires:	dvips
BuildRequires:	tetex-latex
%endif
%if %{build_libstdcxx_docs}
BuildRequires: doxygen
BuildRequires: graphviz
%endif
%if %{build_check}
BuildRequires:	dejagnu
%endif
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif
BuildRequires:	libgmp-devel
BuildRequires:	pkgconfig(mpfr)
BuildRequires:	libmpc-devel

%description
A compiler aimed at integrating all the optimizations and features
necessary for a high-performance and stable development environment.
This package is required for all other GCC compilers, namely C++,
Fortran 95, Objective C, Java and Ada 95.

%package -n %{libgcc_name}
Summary:	GNU C library
Group:		System/Libraries
Provides:	%{libgcc_name_orig} = %{version}-%{release}
Obsoletes:	%{libgcc_name_orig}%{branch}
Provides:	%{libgcc_name_orig}%{branch} = %{version}-%{release}
Obsoletes:	%{libgcc_name_orig}3.0
Provides:	%{libgcc_name_orig}3.0 = %{version}-%{release}
Provides:	%{libgcc_name_orig}3.2 = %{version}-%{release}
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libgcc_name}
The %{libgcc_name} package contains GCC shared libraries for gcc %{branch}

####################################################################
# C++ Compiler

%package c++
Summary:	C++ support for gcc
Group:		Development/C++
%if %{system_compiler}
Obsoletes:	gcc%{branch}-c++
Provides:	gcc%{branch}-c++ = %{version}-%{release}
%else
Conflicts:	%{cross_prefix}gcc%{branch}-c++ < %{version}-%{release}
%endif
Requires:	%{name} = %{version}-%{release}
%if %{system_compiler}
# some day, rpm will be smart enough: #if (#{system_compiler} || #{build_cross}) && !#{build_monolithic}
%if %{libc_shared}
Requires:	%{libstdcxx_name} = %{version}
%endif
Requires:	%{libstdcxx_name_orig}-devel = %{version}
%endif
Requires:	 %{libgomp_name_orig}-devel

%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif
Requires(post): update-alternatives
Requires(postun): update-alternatives

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does include the static standard C++
library and C++ header files; the library for dynamically linking
programs is available separately.

####################################################################
# gcc Plugins
%package -n %{name}-plugins
Summary:	Headers to build gcc plugins
Group:		Development/C
%description -n %{name}-plugins
This package contains the headers needed to build gcc plugins.

####################################################################
# C++ Libraries

%package -n %{libstdcxx_name}
Summary:	GNU C++ library
Group:		System/Libraries
Provides:	%{libstdcxx_name_orig} = %{version}-%{release}
%if "%{branch}" == "3.3"
# By default, the libstdc++ from gcc3.3 is ABI compatible with the one
# from gcc3.2. Just tell other packages about it if they relied on that.
Provides:	%{libstdcxx_name_orig}3.2 = %{version}-%{release}
%endif
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libstdcxx_name}
This package contains the GCC Standard C++ Library v3, an ongoing
project to implement the ISO/IEC 14882:1998 Standard C++ library.

%package -n %{libstdcxx_name_orig}-devel
Summary:	Header files and libraries for C++ development
Group:		Development/C++
Recommends:	%{libstdcxx_name_orig}-python-devel
Conflicts:	%{libstdcxx_name_orig}-python-devel < 9.2.1-0.20190831.3
%if %{libc_shared}
Requires:	%{libstdcxx_name} = %{version}-%{release}
%endif
Provides:	%{libstdcxx_name_orig}6-devel
Obsoletes:	%{libstdcxx_name_orig}6-devel
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libstdcxx_name_orig}-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development.

%package -n %{libstdcxx_name_orig}-python-devel
Summary:	Python files for C++ development
Group:		Development/C++
Requires:	%{libstdcxx_name_orig}-devel = %{version}-%{release}
Conflicts:	%{libstdcxx_name_orig}-devel < 9.2.1-0.20190831.3
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libstdcxx_name_orig}-python-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the python files needed for C++ development.

%package -n %{libstdcxx_name_orig}-static-devel
Summary:	Static libraries for C++ development
Group:		Development/C++
Requires:	%{libstdcxx_name_orig}-devel = %{version}-%{release}
Provides:	%{libstdcxx_name_orig}6-static-devel
Obsoletes:	%{libstdcxx_name_orig}6-static-devel
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libstdcxx_name_orig}-static-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the static libraries needed for C++ development.

####################################################################
# Objective C Compiler

%package objc
Summary:	Objective C support for gcc
Group:		Development/Other
%if %{system_compiler}
Obsoletes:	gcc%{branch}-objc
Provides:	gcc%{branch}-objc = %{version}-%{release}
%endif
Requires:	%{name} = %{version}-%{release}
%if %{libc_shared} && !%{build_monolithic}
Requires:	%{libobjc_name} = %{version}-%{release}
%endif
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is an object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
Objective C object library.

####################################################################
# Objective C++ Compiler

%package objc++
Summary:	Objective C++ support for gcc
Group:		Development/Other
%if %{system_compiler}
Obsoletes:	gcc%{branch}-objc++
Provides:	gcc%{branch}-objc++ = %{version}-%{release}
%endif
Requires:	%{name}-objc = %{version}-%{release}
Requires:	%{name}-c++ = %{version}-%{release}
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description objc++
This package adds Objective C++ support to the GNU C++ compiler.

####################################################################
# Objective C Libraries

%package -n %{libobjc_name}
Summary:	Objective C runtime libraries
Group:		System/Libraries
Obsoletes:	%{libobjc_name_orig}3.0, %{libobjc_name_orig}3.1
Provides:	%{libobjc_name_orig} = %{version}-%{release}
Provides:	%{libobjc_name_orig}3.0 = %{version}-%{release}
Provides:	%{libobjc_name_orig}3.1 = %{version}-%{release}
%if !%{system_compiler}
Conflicts:	%{name}-objc < %{branch}
%endif
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libobjc_name}
Runtime libraries for the GNU Objective C Compiler.

####################################################################
# Fortran 95 Compiler

%package gfortran
Summary:	Fortran 95 support for gcc
Group:		Development/Other
%if %{system_compiler}
Obsoletes:	gcc%{branch}-gfortran
Provides:	gcc%{branch}-gfortran = %{version}-%{release}
%endif
Requires:	%{name} = %{version}-%{release}
%if %{build_quadmath}
Requires:	quadmath-devel = %{version}-%{release}
%endif
%if %{libc_shared} && !%{build_monolithic}
Requires:	%{libgfortran_name} = %{version}-%{release}
%endif
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description gfortran
This package adds support for compiling Fortran 95 programs with the GNU
compiler.

####################################################################
# Fortran 95 Libraries

%package -n %{libgfortran_name}
Summary:	Fortran 95 runtime libraries
Group:		System/Libraries
%if %{build_quadmath}
Requires:	%{libquadmath_name} = %{version}-%{release}
%endif
Provides:	%{libgfortran_name_orig} = %{version}
Obsoletes:	%{libgfortran_name_orig}%{branch}
Provides:	%{libgfortran_name_orig}%{branch} = %{version}-%{release}
Obsoletes:	libgfortran0
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libgfortran_name}
This package contains Fortran 95 shared library which is needed to run
Fortran 95 dynamically linked programs.

####################################################################
# Quadmath Libraries

%if %{build_quadmath}
%package -n %{libquadmath_name}
Summary:	GCC __float128 shared support library
Group:		System/Libraries
Provides:	%{libquadmath_name_orig} = %{version}-%{release}

%description -n %{libquadmath_name}
This package contains GCC shared support library which is needed
for __float128 math support and for Fortran REAL*16 support.

%package -n %{libquadmath_name_orig}-devel
Summary:	GCC __float128 support
Group:		Development/C
Provides:	quadmath-devel = %{version}-%{release}

%description -n %{libquadmath_name_orig}-devel
This package contains support for building Fortran programs using
REAL*16 and programs using __float128 math.
%endif

####################################################################
# ITM Libraries

%if %{build_libitm}
%package -n %{libitm_name}
Summary:	The GNU Transactional Memory library
Group:		System/Libraries
Provides:	%{libitm_name_orig} = %{version}-%{release}

%description -n %{libitm_name}
This package contains the GNU Transactional Memory library
which is a GCC transactional memory support runtime library.

%package -n %{libitm_name_orig}-devel
Summary:	The GNU Transactional Memory library devel files
Group:		Development/C
Provides:	libitm-devel = %{version}-%{release}
Requires: 	%{libitm_name_orig} = %{version}-%{release}
Requires: 	gcc = %{version}-%{release}

%description -n %{libitm_name_orig}-devel
This package contains headers and support files for the
GNU Transactional Memory library.
%endif

####################################################################
# Address Sanitizer Libraries

%if %{build_libasan}
%package -n %{libasan_name}
Summary:	The Address Sanitizer runtime library
Group:		System/Libraries
Provides:	%{libasan_name_orig} = %{version}-%{release}
Conflicts:	libasan5
Obsoletes:	libasan5

%description -n %{libasan_name}
This package contains the Address Sanitizer library
which is used for -fsanitize=address instrumented programs.

%package -n %{libasan_name_orig}-devel
Summary:	The Address Sanitizer runtime library devel files
Group:		Development/C
Provides:	libasan-devel = %{version}-%{release}
Requires:	%{libasan_name} = %{version}-%{release}

%description -n %{libasan_name_orig}-devel
This package contains the devel files for Address Sanitizer library
which is used for -fsanitize=address instrumented programs.
%endif


####################################################################
# Leak Sanitizer Libraries

%if %{build_liblsan}
%package -n %{liblsan_name}
Summary:	The Leak Sanitizer runtime library
Group:		System/Libraries
Provides:	%{liblsan_name_orig} = %{version}-%{release}

%description -n %{liblsan_name}
This package contains the Leak Sanitizer library
which is used for -fsanitize=leak instrumented programs.

%package -n %{liblsan_name_orig}-devel
Summary:	The Leak Sanitizer runtime library devel files
Group:		Development/C
Provides:	liblsan-devel = %{version}-%{release}
Requires:	%{liblsan_name} = %{version}-%{release}

%description -n %{liblsan_name_orig}-devel
This package contains the devel files for Leak Sanitizer library
which is used for -fsanitize=leak instrumented programs.
%endif

####################################################################
# Thread Sanitizer Libraries

%if %{build_libtsan}
%package -n %{libtsan_name}
Summary:	The Thread Sanitizer runtime library
Group:		System/Libraries
Provides:	%{libtsan_name_orig} = %{version}-%{release}

%description -n %{libtsan_name}
This package contains the Thread Sanitizer library
which is used for -fsanitize=thread instrumented programs.

%package -n %{libtsan_name_orig}-devel
Summary:	The Thread Sanitizer runtime library devel files
Group:		Development/C
Provides:	libtsan-devel = %{version}-%{release}
Requires:	%{libtsan_name} = %{version}-%{release}

%description -n %{libtsan_name_orig}-devel
This package contains the devel files for Thread Sanitizer library
which is used for -fsanitize=thread instrumented programs.
%endif

####################################################################
# Undefined Behaviour Sanitizer Libraries

%if %{build_libubsan}
%package -n %{libubsan_name}
Summary:	The Undefined Behaviour Sanitizer runtime library
Group:		System/Libraries
Provides:	%{libubsan_name_orig} = %{version}-%{release}

%description -n %{libubsan_name}
This package contains the Undefined Behaviour Sanitizer library
which is used for -fsanitize=undefined instrumented programs.

%package -n %{libubsan_name_orig}-devel
Summary:	The Undefined Behaviour Sanitizer runtime library devel files
Group:		Development/C
Provides:	libubsan-devel = %{version}-%{release}
Requires:	%{libubsan_name} = %{version}-%{release}

%description -n %{libubsan_name_orig}-devel
This package contains the devel files for Undefined Behaviour Sanitizer
library which is used for -fsanitize=undefined instrumented programs.
%endif

####################################################################
# The GNU Atomic Libraries

%if %{build_libatomic}
%package -n %{libatomic_name}
Summary:	The GNU Atomic library
Group:		System/Libraries
Provides:	%{libatomic_name_orig} = %{version}-%{release}

%description -n %{libatomic_name}
This package contains the GNU Atomic library which is a GCC support
runtime library for atomic operations not supported by hardware.

%package -n %{libatomic_name_orig}-devel
Summary:	The Thread Sanitizer runtime library devel files
Group:		Development/C
Provides:	libtsan-devel = %{version}-%{release}
Requires:	%{libatomic_name} = %{version}-%{release}

%description -n %{libatomic_name_orig}-devel
This package contains the devel files for the GNU Atomic library
which is a GCC support runtime library for atomic operations not
supported by hardware.
%endif

####################################################################
# The Virtual Table Verification Libraries

%if %{build_libvtv}
%package -n %{libvtv_name}
Summary:	The Virtual Table Verification runtime libraries
Group:		System/Libraries
Provides:	%{libvtv_name_orig} = %{version}-%{release}

%description -n %{libvtv_name}
This package contains the Virtual Table Verification runtime libraries.

%package -n %{libvtv_name_orig}-devel
Summary:	The Virtual Table Verification runtime library devel files
Group:		Development/C
Provides:	libvtv-devel = %{version}-%{release}

%description -n %{libvtv_name_orig}-devel
This package contains the devel files for the Virtual Table Verification
runtime libraries.
%endif

####################################################################
# Ada 95 Compiler

%if %{build_ada}
%package gnat
Summary:	Ada 95 support for gcc
Group:		Development/Other
Requires:	%{libgnat_name} = %{version}-%{release}
%if %{system_compiler}
Obsoletes:	gcc%{branch}-gnat
Provides:	gcc%{branch}-gnat = %{version}-%{release}
Provides:	gcc-gnat = %{version}-%{release}
%endif
Obsoletes:	%{cross_prefix}gnat
Provides:	%{cross_prefix}gnat = %{version}-%{release}
Provides:	%{name}-gnat = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description gnat
This package contains an Ada95 compiler and associated development
tools based on the GNU gcc technology. Ada95 is the object oriented
successor of the Ada83 language. To build this package from sources
you must have installed a binary version to bootstrap the compiler.

####################################################################
# Ada 95 Libraries

%package -n %{libgnat_name}
Summary:	Ada 95 runtime libraries
Group:		System/Libraries
Provides:	%{libgnat_name_orig} = %{version}-%{release}
Obsoletes:	%{cross_prefix}gnat-runtime
Provides:	%{cross_prefix}gnat-runtime = %{version}-%{release}

%description -n %{libgnat_name}
This package contains the shared libraries required to run programs
compiled with the GNU Ada compiler (GNAT) if they are compiled to use
shared libraries.  It also contains the shared libraries for the
Implementation of the Ada Semantic Interface Specification (ASIS), the
implementation of Distributed Systems Programming (GLADE) and the
Posix 1003.5 Binding (Florist).
%endif

####################################################################
# D Compiler

%if %{build_d}
%package gdc
Summary:	D support for gcc
Group:		Development/Other
%if %{system_compiler}
Provides:	gcc%{branch}-d = %{version}-%{release}
Provides:	gdc = %{version}-%{release}
%endif
Requires:	%{name} = %{version}-%{release}
%if %{libc_shared} && !%{build_monolithic}
Requires:       %{libgphobos_name} = %{version}-%{release}
%endif
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description gdc
This package adds support for compiling D programs with the GNU
compiler.

####################################################################
# D Libraries

%package -n %{libgphobos_name}
Summary:	D runtime libraries
Group:		System/Libraries
Provides:	%{libgphobos_name_orig} = %{version}
Provides:	%{libgphobos_name_orig}%{branch} = %{version}-%{release}
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif
%endif

%description -n %{libgphobos_name}
This package contains D shared library which is needed to run
D dynamically linked programs.

####################################################################
# FFI headers and libraries
%if %{build_libffi}
%package -n %{libffi_name}
Summary:	GCC support library for FFI
Group:		System/Libraries

%description -n %{libffi_name}
This package contains GCC shared support library which is needed
for FFI support.

%package -n %{libffi_name}-devel
Summary:	Development headers and static library for FFI
Group:		Development/C
Requires:	%{libffi_name} = %{version}-%{release}
Provides:	%{libffi_name_orig}-devel = %{version}-%{release}
Obsoletes:	%{libffi_name_orig}-devel = 4.3.2
Obsoletes:	%{libffi_name_orig}-devel = 4.3.1
Obsoletes:	%{libffi_name_orig}-devel = 4.2.3
Obsoletes:	%{libffi_name_orig}-devel = 4.2.2
Provides:	ffi-devel = %{version}-%{release}

%description -n %{libffi_name}-devel
This package contains the development headers and the static library
for libffi. The libffi library provides a portable, high level
programming interface to various calling conventions. This allows a
programmer to call any function specified by a call interface
description at run time.
%endif

####################################################################
# SSP headers and libraries
%if %{build_libssp}

%package -n %{libssp_name}
Summary:	GCC SSP shared support library
Group:		System/Libraries

%description -n %{libssp_name}
This package contains GCC shared support library which is needed
for SSP support.

%package -n %{libssp_name_orig}-devel
Summary:	GCC SSP support
Group:		Development/C
Requires:	%{name} = %{version}-%{release}
%if %{libc_shared}
Requires:	%{libssp_name} = %{version}-%{release}
%endif

%description -n %{libssp_name_orig}-devel
This package contains headers and static libraries for building
SSP-instrumented programs.

Refer to the documentation for -fstack-protector.
%endif

####################################################################
# GCC OpenMP headers and library

%package -n %{libgomp_name}
Summary:	GCC OpenMP support library
Group:		System/Libraries

%description -n %{libgomp_name}
This package contains the GCC shared support library which is needed 
for OpenMP support.

%package -n %{libgomp_name_orig}-devel
Summary:	GCC OpenMP support
Group:		Development/C
Requires:	%{name} = %{version}-%{release}
%if %{libc_shared}
Requires:	%{libgomp_name} = %{version}-%{release}
%endif

%description -n %{libgomp_name_orig}-devel
This package contains headers and static libraries for building 
programs that use OpenMP.

####################################################################
# Preprocessor

%package cpp
Summary:	The C Preprocessor
Group:		Development/C
%if %{system_compiler}
Obsoletes:	gcc%{branch}-cpp
Provides:	gcc%{branch}-cpp = %{version}-%{release}
Conflicts:      gcc3.3-cpp < 3.3.6-8
%endif
Requires(post): update-alternatives
Requires(postun): update-alternatives

%description cpp
The C preprocessor is a 'macro processor' which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define 'macros,' which are abbreviations for longer
constructs.

The C preprocessor provides four separate facilities that you can use as
you see fit:

* Inclusion of header files. These are files of declarations that can be
  substituted into your program.
* Macro expansion. You can define 'macros,' which are abbreviations for 
  arbitrary fragments of C code, and then the C preprocessor will replace
  the macros with their definitions throughout the program.
* Conditional compilation. Using special preprocessing directives,
  you can include or exclude parts of the program according to various
  conditions.
* Line control. If you use a program to combine or rearrange source files
  into an intermediate file which is then compiled, you can use line
  control to inform the compiler about where each source line originated.

You should install this package if you are a programmer who is searching for
such a macro processor.


####################################################################
# Documentation

%package doc
Summary:	GCC documentation
Group:		Development/Other
%if %{system_compiler}
Obsoletes:	gcc%{branch}-doc
Provides:	gcc%{branch}-doc = %{version}-%{release}
%endif
BuildArch: noarch

%description doc
GCC is a compiler suite aimed at integrating all the optimizations and
features necessary for a high-performance and stable development
environment. This package contains the compiler documentation in INFO
pages.

%package doc-pdf
Summary:	GCC documentation
Group:		Development/Other
%if %{system_compiler}
Obsoletes:	gcc%{branch}-doc-pdf
Provides:	gcc%{branch}-doc-pdf = %{version}-%{release}
%endif
BuildArch: noarch

%description doc-pdf
GCC is a compiler suite aimed at integrating all the optimizations and
features necessary for a high-performance and stable development
environment. This package contains the compiler printable
documentation in PDF.

%package -n libstdc++-docs
Summary: Documentation for the GNU standard C++ library
Group: Development/Other
BuildArch: noarch

%description -n libstdc++-docs
Manual, doxygen generated API information and Frequently Asked Questions
for the GNU standard C++ library.

%prep
%setup -q -n %{source_dir}
%autopatch -p1

# Setup files for cross-compilation
# XXX embed uClibc / dietlibc sources? [ia64 checks for __GLIBC__]
%if %{build_cross}
sysroot=%{_prefix}/%{gcc_target_platform}
%endif
if [[ -n "$sysroot" ]]; then
mkdir sysroot
cd sysroot
[[ -d $sysroot/bin ]] &&
ln -s $sysroot/bin bin

[[ ! -d usr ]] &&
mkdir usr
%if %{build_cross_bootstrap}
[[ -f $sysroot/include/linux/version.h ]] &&
ln -s $sysroot/include usr/include
%else
[[ -f $sysroot/include/stdio.h ]] &&
ln -s $sysroot/include usr/include
%endif

[[ -f $sysroot/lib/crti.o ]] &&
ln -s $sysroot/lib lib
[[ -f $sysroot/lib64/crti.o ]] &&
ln -s $sysroot/lib64 lib64
[[ -f $sysroot/lib32/crti.o ]] &&
ln -s $sysroot/lib32 lib32
cd ../
fi

# We can actually link binaries at this stage
%if %{build_cross}
perl -pi -e '/^DRIVER_DEFINES/ .. /^gcc/ and s/(\@TARGET_SYSTEM_ROOT_DEFINE\@)/-DSYSROOT_SPEC="\\"\\"" \1/' gcc/Makefile.in
%endif

# Ensure BASE-VER alwaus matches rpm version
echo "%{version}" > gcc/BASE-VER

%build
# Prepare OPT_FLAGS
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g' -e 's/-mcpu=pentiumpro//g'`
%if %{build_debug}
OPT_FLAGS=`echo "$OPT_FLAGS -g" | sed -e "s/-fomit-frame-pointer//g"`
%endif
%if %{build_cross}
OPT_FLAGS="-O2 -g -pipe"
%endif
%if %isarch %{biarches}
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/\(-m64\|-m32\)//g'`
%endif
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-fomit-frame-pointer//g'`

# don't build crt files with -fasynchronous-unwind-tables
case " $OPT_FLAGS " in
*" -fasynchronous-unwind-tables "*)
  perl -pi -e 's/-fno-exceptions /-fno-exceptions -fno-asynchronous-unwind-tables /' gcc/Makefile.in
  ;;
esac

# Force a seperate object dir
rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

# Make bootstrap-lean
LANGUAGES="c"
%if %{build_cxx}
LANGUAGES="$LANGUAGES,c++"
%endif
%if %{build_ada}
LANGUAGES="$LANGUAGES,ada"
%endif
%if %{build_fortran}
LANGUAGES="$LANGUAGES,fortran"
%endif
%if %{build_objc}
LANGUAGES="$LANGUAGES,objc"
%if %{build_objc_gc}
LIBOBJC_FLAGS="--enable-objc-gc"
%endif
%endif
%if %{build_objcp}
LANGUAGES="$LANGUAGES,obj-c++"
%endif
%if %{build_d}
LANGUAGES="$LANGUAGES,d"
%endif
PROGRAM_SUFFIX=""
%if "%{program_suffix}" != ""
PROGRAM_SUFFIX="--program-suffix=%{program_suffix}"
%endif
PROGRAM_PREFIX=""
%if "%{program_prefix}" != ""
PROGRAM_PREFIX="--program-prefix=%{program_prefix}"
%endif
%if %{build_cxx}
LIBSTDCXX_FLAGS="--enable-long-long --enable-__cxa_atexit --disable-libunwind-exceptions"
case %{libc} in
glibc)		LIBSTDCXX_FLAGS="$LIBSTDCXX_FLAGS --enable-clocale=gnu";;
esac
%endif
SSP_FLAGS="--disable-ssp --disable-libssp"
%if %{build_libssp}
SSP_FLAGS="--enable-ssp --enable-libssp"
%endif
%if %{use_ssp_glibc}
SSP_FLAGS="--enable-ssp --disable-libssp"
%endif
%if !%{build_quadmath}
QUADMATH_FLAGS="--disable-quadmath"
%endif
%if !%{build_libgomp}
LIBGOMP_FLAGS="--disable-libgomp"
%endif
%if %{build_isl}
ISL_FLAGS="--with-isl"
%endif
%if !%{build_libffi}
LIBFFI_FLAGS="--disable-libffi"
%endif
%if %{build_cross}
CROSS_FLAGS="--with-build-sysroot=$PWD/../sysroot --with-headers --disable-nls"
%endif
%if %{build_cross_bootstrap}
CROSS_FLAGS="--disable-threads"
%endif
%if !%{system_compiler} && !%{build_stdcxxheaders}
LIBSTDCXX_FLAGS="$LIBSTDCXX_FLAGS --with-gxx-include-dir=%{libstdcxx_includedir}"
%endif
[[ -n "$CROSS_FLAGS" ]] && CROSS_FLAGS="$CROSS_FLAGS --target=%{gcc_target_platform}"
case %{libc} in
%if %{build_cross_bootstrap}
glibc)		LIBC_FLAGS="";;
%else
glibc)		LIBC_FLAGS="--enable-threads=posix --with-linker-hash-style=gnu";;
%endif
newlib)		LIBC_FLAGS="--with-newlib --with-headers --disable-threads";;
*)		echo "ERROR: unsupported %{libc} C library"; exit 1;;
esac
%if %{libc_shared}
LIBC_FLAGS="$LIBC_FLAGS --enable-shared"
%else
LIBC_FLAGS="$LIBC_FLAGS --disable-shared"
%endif
# target specific flags (don't %ifarch for cross compilers)
case %{target_cpu} in
x86_64)		TARGET_FLAGS="--with-cpu=generic";;
i?86|athlon)	TARGET_FLAGS="--with-cpu=generic";;
armv7hl)     TARGET_FLAGS=" --with-arch=armv7-a --with-float=hard --with-fpu=vfpv3-d16 --with-abi=aapcs-linux";;
esac

# (anssi) building with external jar fails
%define python_dir %(echo "%{python3_sitelib}" | sed 's!^%{_prefix}!!g')
CC="%{__cc}" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --libexecdir=%{_prefix}/lib --with-slibdir=%{target_slibdir} \
	--with-pkgversion="Mageia %{version}-%{release}" --with-bugurl=https://bugs.mageia.org/ \
	--mandir=%{_mandir} --infodir=%{_infodir} --enable-checking=release \
	--enable-languages="$LANGUAGES" $PROGRAM_PREFIX $PROGRAM_SUFFIX --enable-linker-build-id \
	--build=%{_target_platform} --host=%{_target_platform} $CROSS_FLAGS $TARGET_FLAGS \
	--with-system-zlib $LIBC_FLAGS $LIBOBJC_FLAGS $LIBSTDCXX_FLAGS $SSP_FLAGS \
	$QUADMATH_FLAGS $LIBFFI_FLAGS --disable-werror $LIBGOMP_FLAGS \
	$ISL_FLAGS --with-python-dir=%{python_dir} --enable-lto --with-gcc-major-version-only
touch ../gcc/c-gperf.h
%if %{build_cross}
%make_build
%else
# bootstrap-lean is similar to bootstrap except "object files from the stage1
# and stage2 of the 3-stage bootstrap of the compiler are deleted as soon as
# they are no longer needed."
%make_build bootstrap-lean BOOT_CFLAGS="$OPT_FLAGS"
%endif

cd ..

# Copy various doc files here and there
mkdir -p rpm.doc/gfortran
mkdir -p rpm.doc/objc
mkdir -p rpm.doc/objcp
mkdir -p rpm.doc/libobjc
mkdir -p rpm.doc/boehm-gc
mkdir -p rpm.doc/c++
mkdir -p rpm.doc/libstdc++
mkdir -p rpm.doc/gdc

%if %{build_libstdcxx}
(cd libstdc++-v3; for i in ChangeLog*; do
	ln -f $i ../rpm.doc/libstdc++/$i
done)
%endif
%if %{build_cxx}
(cd gcc/cp; for i in ChangeLog*; do
	ln -f $i ../../rpm.doc/c++/$i
done)
%endif
%if %{build_fortran}
(cd gcc/fortran; for i in ChangeLog*; do
	ln -f $i ../../rpm.doc/gfortran/$i
done)
(cd libgfortran; for i in ChangeLog*; do
	ln -f $i ../rpm.doc/gfortran/$i.libgfortran
done)
%endif
%if %{build_objc}
(cd gcc/objc; for i in ChangeLog*; do
	ln -f $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in ChangeLog*; do
	ln -f $i ../rpm.doc/libobjc/$i.libobjc
done)
%endif
%if %{build_objcp}
(cd gcc/objcp; for i in ChangeLog*; do
	ln -f $i ../../rpm.doc/objcp/$i.objcp
done)
%endif
%if %{build_d}
(cd gcc/d; for i in ChangeLog*; do
	ln -f $i ../../rpm.doc/gdc/$i.gdclib64phoboslib64phobos
done)
%endif

# [ghibo] - build printable documentation
%if %{build_pdf_doc}
export PDFTEX=pdftex
unset TEXINPUTS
(cd gcc/doc; for file in gcc.texi cpp.texi cppinternals.texi; do
  texi2dvi -p -t @afourpaper -t @finalout -I ./include -I ../../obj-%{gcc_target_platform}/gcc $file
done)
(cd gcc/fortran;
  texi2dvi -p -t @afourpaper -t @finalout -I ../doc/include -I ../../obj-%{gcc_target_platform}/gcc gfortran.texi)
%if %{build_ada}
(cd gcc/ada;
  texi2dvi -p -t @afourpaper -t @finalout -I ../doc/include -I ../../obj-%{gcc_target_platform}/gcc gnat_rm.texi)
(cd obj-%{gcc_target_platform}/gcc/doc;
  texi2dvi -p -t @afourpaper -t @finalout -I ../../../gcc/doc/include -I .. gnat_ugn.texi
  mv gnat_ugn.pdf ../../../gcc/ada/gnat_ugn.pdf)
%endif
%endif

# Make generated doxygen pages.
%if %{build_libstdcxx_docs}
cd obj-%{gcc_target_platform}/%{gcc_target_platform}/libstdc++-v3
make doc-html-doxygen
make doc-man-doxygen
cd ../..
%endif

%check
echo ====================TESTING=========================
%if %{build_check}
cd obj-%{gcc_target_platform}
time %make_build -k check || true
echo "XXX check time above XXX"
../contrib/test_summary > ../test_summary.log
cd ..
%endif
echo ====================TESTING END=====================
 
%install
# Create some directories, just to make sure (e.g. ColorGCC)
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}
mkdir -p %{buildroot}%{_infodir}
mkdir -p %{buildroot}%{_sysconfdir}

pushd obj-%{gcc_target_platform};
  %make_install
%if %{build_libstdcxx_docs}
  libstdcxx_doc_builddir=%{gcc_target_platform}/libstdc++-v3/doc/doxygen
  mkdir -p ../rpm.doc/libstdc++-v3
  cp -r -p ../libstdc++-v3/doc/html ../rpm.doc/libstdc++-v3/html
  cp -r -p $libstdcxx_doc_builddir/html ../rpm.doc/libstdc++-v3/html/api
  mkdir -p %{buildroot}%{_mandir}/man3
  cp -r -p $libstdcxx_doc_builddir/man/man3/* %{buildroot}%{_mandir}/man3/
%endif
popd

FULLVER=`%{buildroot}%{_bindir}/%{gcc_target_platform}-gcc%{program_suffix} --version | head -n 1 | cut -d' ' -f3`
FULLPATH=$(dirname %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{branch}/cc1)

# Create /usr/bin/%{program_prefix}gcc%{branch}-version that contains the full version of gcc
cat >%{buildroot}%{_bindir}/%{program_prefix}gcc%{branch}-version <<EOF
#!/bin/sh
echo "$FULLVER"
EOF
chmod 0755 %{buildroot}%{_bindir}/%{program_prefix}gcc%{branch}-version

%if "%{program_suffix}" == ""
mv %{buildroot}%{_bindir}/%{program_prefix}cpp %{buildroot}%{_bindir}/%{program_prefix}cpp-%{branch}
mv %{buildroot}%{_bindir}/%{program_prefix}gcc %{buildroot}%{_bindir}/%{program_prefix}gcc-%{branch}
mv %{buildroot}%{_bindir}/%{program_prefix}gcc-ar %{buildroot}%{_bindir}/%{program_prefix}gcc-ar-%{branch}
mv %{buildroot}%{_bindir}/%{program_prefix}gcc-nm %{buildroot}%{_bindir}/%{program_prefix}gcc-nm-%{branch}
mv %{buildroot}%{_bindir}/%{program_prefix}gcc-ranlib %{buildroot}%{_bindir}/%{program_prefix}gcc-ranlib-%{branch}
%if %{build_cxx}
mv %{buildroot}%{_bindir}/%{program_prefix}g++ %{buildroot}%{_bindir}/%{program_prefix}g++-%{branch}
mv %{buildroot}%{_bindir}/%{program_prefix}c++ %{buildroot}%{_bindir}/%{program_prefix}c++-%{branch}
%endif
%endif

# replacing hardlinks with symlinks
ln -sf %{program_prefix}gcc%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gcc%{program_suffix}
ln -sf %{program_prefix}gcc-ar%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gcc-ar%{program_suffix}
ln -sf %{program_prefix}gcc-nm%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gcc-nm%{program_suffix}
ln -sf %{program_prefix}gcc-ranlib%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gcc-ranlib%{program_suffix}
ln -sf %{program_prefix}gcc-ar%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-ar%{program_suffix}
ln -sf %{program_prefix}gcc-nm%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-nm%{program_suffix}
ln -sf %{program_prefix}gcc-ranlib%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-ranlib%{program_suffix}
# TODO: cleanups?
%if "%{program_prefix}" != "%{gcc_target_platform}-"
ln -sf %{program_prefix}gcc%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gcc-%{branch}
ln -sf %{program_prefix}gcc-ar%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-ar-%{branch}
ln -sf %{program_prefix}gcc-nm%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-nm-%{branch}
ln -sf %{program_prefix}gcc-ranlib%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-ranlib-%{branch}
%endif
%if %{build_cxx}
%if !%{build_cross}
ln -sf %{program_prefix}g++%{program_long_suffix} %{buildroot}%{_bindir}/c++%{program_long_suffix}
%endif
ln -sf %{program_prefix}g++%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-c++%{program_suffix}
ln -sf %{program_prefix}g++%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-g++%{program_suffix}
%endif
%if %{build_fortran}
ln -sf %{program_prefix}gfortran%{program_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gfortran%{program_suffix}
%endif
%if %{build_d}
ln -sf %{program_prefix}gdc%{program_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gdc%{program_suffix}
%endif

%if %{system_compiler}
ln -s gcc %{buildroot}%{_bindir}/cc
%endif

%if %{build_cross_bootstrap}
# libgcc_eh.a is needed for glibc _but_ it is not built at this stage
# (disabled-shared)
# workaround by symlinking to libgcc. The other possibility would be to
# workaround at glibc level but it would be more painful.
ln -sf %{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgcc.a \
	%{buildroot}/%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgcc_eh.a
%endif
rm -f %{buildroot}%{_infodir}/dir

%if %{build_ada} && %{libc_shared}
%if %isarch x86_64
rm -rf $FULLPATH/32/ada{include,lib}
%endif
# Dispatch Ada 95 libraries (special case)
pushd $FULLPATH/adalib
  rm -f libgnarl.so* libgnat.so*
  mv -f libgnarl-%{libgnat_major}.so %{buildroot}%{_libdir}/
  ln -s ../../../../../%{_lib}/libgnarl-%{libgnat_major}.so libgnarl.so
  ln -s ../../../../../%{_lib}/libgnarl-%{libgnat_major}.so libgnarl-%{libgnat_major}.so
  mv -f libgnat-%{libgnat_major}.so %{buildroot}%{_libdir}/
  ln -s ../../../../../%{_lib}/libgnat-%{libgnat_major}.so libgnat.so
  ln -s ../../../../../%{_lib}/libgnat-%{libgnat_major}.so libgnat-%{libgnat_major}.so
popd
%endif

# Strip debug info from libraries
STRIP_DEBUG=/bin/true
%if !%{build_debug}
if [[ "%{_enable_debug_packages}" != "1" ]]; then
  STRIP_DEBUG="strip -g"
  if [[ "%{_target_cpu}" != "%{target_cpu}" ]]; then
    STRIP_DEBUG="%{target_cpu}-linux-$STRIP_DEBUG"
  fi
fi
%endif

# Dispatch libraries to the right directories
DispatchLibs() {
	libname=$1 libversion=$2
	[[ -f ../../../../..%{target_libdir}/$libname.so.$libversion ]] && {
	$STRIP_DEBUG ../../../../..%{target_libdir}/$libname.so.$libversion
	rm -f $libname.so
	ln -s ../../../../..%{target_libdir}/$libname.so.$libversion $libname.so
	rm -f ../../../../..%{target_libdir}/$libname.so
	} || :
	[[ -f ../../../../..%{target_libdir}/$libname.a ]] && {
	$STRIP_DEBUG ../../../../..%{target_libdir}/$libname.a
	rm -f $libname.a
	cp -f ../../../../..%{target_libdir}/$libname.a $libname.a
	rm -f ../../../../..%{target_libdir}/$libname.a
	} || :
	%if %isarch %{biarches}
	[ -d 32 ] || mkdir 32
	pushd 32
	mkdir -p %{buildroot}%{_prefix}/lib
	skip32=
	[[ -z "$skip32" ]] && [[ -f ../../../../$libname.so.$libversion ]] && {
	$STRIP_DEBUG ../../../../$libname.so.$libversion
	ln -s ../../../../$libname.so.$libversion $libname.so
	rm -f ../../../../$libname.so
	[[ -f ../../../../$libname.a ]] && {
	$STRIP_DEBUG ../../../../$libname.a
	cp -f ../../../../$libname.a $libname.a
	rm -f ../../../../$libname.a
	} || :
	} || :
	popd
	%endif
	%if %isarch %{nof_arches}
	[ -d nof ] || mkdir nof
	pushd nof
	$STRIP_DEBUG ../../../../nof/$libname.so.$libversion
	ln -s ../../../../nof/$libname.so.$libversion $libname.so
	rm -f ../../../../nof/$libname.so
	[[ -f ../../../../nof/$libname.a ]] && {
	$STRIP_DEBUG ../../../../nof/$libname.a
	cp -f ../../../../nof/$libname.a $libname.a
	rm -f ../../../../nof/$libname.a
	} || :
	popd
	%endif
}
pushd $FULLPATH
	%if %{build_libssp}
	DispatchLibs libssp		%{libssp_major}.0.0
	mv ../../../../..%{target_libdir}/libssp_nonshared.a libssp_nonshared.a
	%if %isarch %{biarches}
	mv ../../../libssp_nonshared.a 32/libssp_nonshared.a
	%endif
	%endif
        %if %{build_libgomp}
	DispatchLibs libgomp		%{libgomp_major}.0.0
        %endif
	%if %{build_cxx}
	DispatchLibs libstdc++	%{libstdcxx_major}.0.%{libstdcxx_micro}
	mv ../../../../..%{target_libdir}/libsupc++.a libsupc++.a
	%if %isarch %{biarches}
	mv -f ../../../libsupc++.a 32/libsupc++.a
	%endif
	%if %isarch %{nof_arches}
	mv -f ../../../nof/libsupc++.a nof/libsupc++.a
	%endif
	%endif
	# Make it less hard dependent on libstdc++ 3.4 minor changes
	%if !%{system_compiler}
	[[ -f  ../../../../..%{target_libdir}/libstdc++.so.%{libstdcxx_major} ]] &&
	ln -sf ../../../../..%{target_libdir}/libstdc++.so.%{libstdcxx_major} libstdc++.so || :
	%if %isarch %{biarches}
	[[ -f  ../../../libstdc++.so.%{libstdcxx_major} ]] &&
	ln -sf ../../../../libstdc++.so.%{libstdcxx_major} 32/libstdc++.so || :
	%endif
	%endif
	%if %{build_objc}
	DispatchLibs libobjc	%{libobjc_major}.0.0
	%if %{build_objc_gc}
	DispatchLibs libobjc_gc	%{libobjc_major}.0.0
	%endif
	%endif
	%if %{build_fortran}
	DispatchLibs libgfortran	%{libgfortran_major}.0.0
	[[ -f ../../../libgfortranbegin.a ]] &&
	mv -f ../../../libgfortranbegin.a 32/libgfortranbegin.a || :
	%if %isarch %{nof_arches}
	[[ -f ../../../nof/libgfortranbegin.a ]] &&
	mv -f ../../../nof/libgfortranbegin.a nof/libgfortranbegin.a || :
	%endif
	%endif
	%if %{build_d}
	DispatchLibs libgphobos		%{libgphobos_major}.0.0
	DispatchLibs libgdruntime	%{libgphobos_major}.0.0
	%endif
popd

# Copy <cxxabi.h> to compiler-specific directories to keep backward compatibility
%if %{build_cxx}
mkdir -p $FULLPATH/include/bits/
cp %{buildroot}%{libstdcxx_includedir}/cxxabi.h $FULLPATH/include/
cp %{buildroot}%{libstdcxx_includedir}/%{gcc_target_platform}/bits/cxxabi_tweaks.h $FULLPATH/include/bits/
%endif

# Ship with biarch c++config.h headers
%if %{build_cxx}
pushd obj-%{gcc_target_platform}
cxxconfig="`find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h`"
for i in `find %{gcc_target_platform}/[36]*/libstdc++-v3/include -name c++config.h 2>/dev/null`; do
  if ! diff -up $cxxconfig $i; then
    file_32=x file_64=x
    case $i in
      %{gcc_target_platform}/32/*) file_32=$i; file_64=$cxxconfig ;;
      %{gcc_target_platform}/64/*) file_32=$cxxconfig; file_64=$i ;;
    esac
    { [[ -f "$file_32" ]] && [[ -f "$file_64" ]]; } ||
      { echo "c++config.h dispatch error"; exit 1; }

    cat > %{buildroot}%{libstdcxx_includedir}/%{gcc_target_platform}/bits/c++config.h <<EOF
#ifndef _CPP_CPPCONFIG_WRAPPER
#define _CPP_CPPCONFIG_WRAPPER 1
#include <bits/wordsize.h>
#if __WORDSIZE == 32
`cat $file_32`
#else
`cat $file_64`
#endif
#endif
EOF
    break
  fi
done
popd
%endif

# Link gnatgcc to gcc
%if %{build_ada}
ln -sf gcc %{buildroot}%{_bindir}/gnatgcc
%endif

# Create an empty file with perms 0755
FakeAlternatives() {
  for file in ${1+"$@"}; do
    rm -f %{cross_program_prefix}$file
    touch %{cross_program_prefix}$file
    chmod 0755 %{cross_program_prefix}$file
  done
}

# Alternatives provide /lib/cpp and %{_bindir}/cpp
(cd %{buildroot}%{_bindir}; FakeAlternatives cpp)
%if !%{build_cross} && %{system_compiler}
(mkdir -p %{buildroot}/lib; cd %{buildroot}/lib; ln -sf %{_bindir}/cpp cpp)
%endif

# Alternatives provide /usr/bin/c++
%if %{build_cxx}
(cd %{buildroot}%{_bindir}; FakeAlternatives c++)
%endif

if [[ -z "%{?cross_bootstrap:1}" ]] && [[ "%{libc_shared}" = "1" ]]; then
# Move libgcc_s.so* to /%{_lib}
pushd %{buildroot}%{_prefix}/%{target_lib}
  chmod 0755 libgcc_s.so.%{libgcc_major}
  mkdir -p %{buildroot}%{target_slibdir}
  mv -f  libgcc_s.so.%{libgcc_major} %{buildroot}%{target_slibdir}/libgcc_s-%{branch}.so.%{libgcc_major}
  ln -sf libgcc_s-%{branch}.so.%{libgcc_major} %{buildroot}%{target_slibdir}/libgcc_s.so.%{libgcc_major}
  # WARNING:
  # if there's a libgcc_s.so, it's a linker script. should be used instead of libgcc_s.so.*
  # to avoid build errors. At least ARM need this kind of specific care.
  if [ -f %{buildroot}/usr/%{target_lib}/libgcc_s.so ]; then
    mkdir -p %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{branch}
    mv -f %{buildroot}/usr/%{target_lib}/libgcc_s.so %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{branch}/
  else
    ln -sf %{target_slibdir}/libgcc_s.so.%{libgcc_major} %{buildroot}%{target_libdir}/libgcc_s.so
  fi
%if %isarch %{nof_arches}
  chmod 0755 nof/libgcc_s.so.%{libgcc_major}
  mkdir -p %{buildroot}%{target_slibdir}/nof
  mv -f  nof/libgcc_s.so.%{libgcc_major} %{buildroot}%{target_slibdir}/nof/libgcc_s-%{branch}.so.%{libgcc_major}
  ln -sf libgcc_s-%{branch}.so.%{libgcc_major} %{buildroot}%{target_slibdir}/nof/libgcc_s.so.%{libgcc_major}
  ln -sf %{target_slibdir}/nof/libgcc_s.so.%{libgcc_major} %{buildroot}%{target_libdir}/nof/libgcc_s.so
%endif
popd
%if %isarch %{biarches}
pushd %{buildroot}%{_prefix}/lib
  chmod 0755 libgcc_s.so.%{libgcc_major}
  mkdir -p %{buildroot}/lib
  mv -f  libgcc_s.so.%{libgcc_major} %{buildroot}/lib/libgcc_s-%{branch}.so.%{libgcc_major}
  ln -sf libgcc_s-%{branch}.so.%{libgcc_major} %{buildroot}/lib/libgcc_s.so.%{libgcc_major}
  ln -sf ../../lib/libgcc_s.so.%{libgcc_major} %{buildroot}%{_prefix}/lib/libgcc_s.so
  ln -sf ../../lib/libgcc_s.so.%{libgcc_major} %{buildroot}%{_prefix}/lib/libgcc_s_32.so
popd
%endif
fi

# Create c89 and c99 wrappers
%if %{system_compiler}
cat > %{buildroot}%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec %{_bindir}/gcc-%{branch} $fl ${1+"$@"}
EOF
cat > %{buildroot}%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec %{_bindir}/gcc-%{branch} $fl ${1+"$@"}
EOF
chmod 755 %{buildroot}%{_prefix}/bin/c?9
%endif

# FIXME: cpp, gcov manpages names
pushd %{buildroot}%{_mandir}/man1;
  if [[ -n "%{program_prefix}%{program_suffix}" ]]; then
    for f in gcov cpp gcc g++ gfortran gdc; do
      [[ -f "$f.1" ]] && mv $f.1 %{program_prefix}$f%{program_suffix}.1 || :
    done
  fi
popd

# Fix info pages
if [[ "%{name}" = "gcc%{branch}" ]]; then
  pushd %{buildroot}%{_infodir}/
  for f in cpp cppinternals gcc gfortran gdc gnat-style gnat_rm gnat_ugn; do
    if [[ -f "$f.info" ]]; then
      perl -pe "/^START-INFO-DIR-ENTRY/ .. /^END-INFO-DIR-ENTRY/ and s/($f)/\${1}-%{branch}/ig" $f.info > ${f}-%{branch}.info
      rm -f $f.info
    fi
  done
  popd
fi

# Sanitize rpath
for bin in %{buildroot}%{_bindir}/* $FULLPATH/*.so $FULLPATH/ecj1; do
  if [[ ! -f $bin ]]; then
    continue
  fi
  oldrpath=$(chrpath -l $bin | awk -F= '{ print $2 }')
  newrpath=
  for rpathdir in ${oldrpath//:/ }; do
    rpathdir=${rpathdir/lib\/..\/lib64/lib64}
    [[ "$rpathdir" != "%{_libdir}" ]] || continue
    newrpath=$newrpath:$rpathdir
  done
  newrpath=${newrpath#:}
  [[ "$newrpath" != "$oldrpath" ]] || continue
  if [[ "$newrpath" == "" ]]; then
    chrpath -d $bin
  else
    chrpath -r $newrpath $bin
  fi
done

%if %{system_compiler}
%define find_lang /usr/lib/rpm/find-lang.sh %buildroot
%find_lang %{name}
%find_lang cpplib
%if %{build_cxx}
%find_lang libstdc++
%endif
%else
touch %{name}.lang cpplib.lang libstdc++.lang
%endif

# Remove unpackaged files
rm  -f %{buildroot}%{_bindir}/jar
rm  -f %{buildroot}%{_bindir}/addr2name.awk
rm -rf %{buildroot}%{_prefix}/doc
rm -rf %{buildroot}%{_mandir}/man7
rm  -f %{buildroot}%{target_libdir}/*.la
rm  -f %{buildroot}%{_prefix}/lib/libiberty.a
rm  -f %{buildroot}%{_prefix}/lib64/libiberty.a
rm  -f %{buildroot}%{target_libdir}*/libiberty.a
%if %isarch %{biarches}
rm  -f %{buildroot}%{_prefix}/lib/*.la
rm  -f %{buildroot}%{_prefix}/lib/32/libiberty.a
%endif
rm -rf %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{branch}/install-tools
%if !%{build_doc}
rm -fr %{buildroot}/%{_datadir}/info/
%endif
%if !%{build_quadmath}
rm -f %{buildroot}/%{_datadir}/info/libquadmath*
%endif

%if %{build_cross}
rm %{buildroot}%{_mandir}/man1/%{program_prefix}gcov%{program_suffix}.1*
rm %{buildroot}%{_bindir}/%{program_prefix}gcov%{program_suffix}
%endif


%if !%system_compiler && !%build_cross && %libc_shared
rm %{buildroot}%{target_slibdir}/libgcc_s-%{branch}.so.%{libgcc_major}
rm %{buildroot}%{target_slibdir}/libgcc_s.so.%{libgcc_major}
rm %{buildroot}%{target_libdir}/libgcc_s.so
%if %isarch %{biarches}
rm %{buildroot}%{target_slibdir32}/libgcc_s-%{branch}.so.%{libgcc_major}
rm %{buildroot}%{target_slibdir32}/libgcc_s.so.%{libgcc_major}
rm %{buildroot}%{target_libdir}/../lib/libgcc_s.so
rm %{buildroot}%{target_libdir}/../lib/libgcc_s_32.so
%endif
%endif
%if %build_cross && !%{build_cross_bootstrap}
rm -f %{buildroot}/usr/%{target_lib}/libgcc_s.so
%endif

# lsan is only available on x86_64, no need to expose header on other arches
%ifnarch x86_64 aarch64
rm -f %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/sanitizer/lsan_interface.h
%endif

# limits.h and syslimits.h are needed in includedir
mv %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include-fixed/{sys,}limits.h \
	%{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include
rm -r %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include-fixed

%if !%{system_compiler}
rm -f %{buildroot}%{_infodir}/gccinstall.info*
rm -f %{buildroot}%{_infodir}/gccint.info*
rm -rf %{buildroot}%{_datadir}/locale
%endif
rm -f %{buildroot}%{_infodir}/cp-tools.info

# In case we are cross-compiling, don't bother to remake symlinks and
# don't let spec-helper when stripping files either
%if %build_cross
export DONT_SYMLINK_LIBS=1
export DONT_STRIP=1
%endif

%if %{build_debug}
# Don't strip in debug mode
export DONT_STRIP=1
%endif

%if %{build_libstdcxx}
%if %build_cross && !%{build_cross_bootstrap}
rm -f %{buildroot}%{target_libdir}/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.py
%else
mkdir -p %{buildroot}%{_datadir}/gdb/auto-load/%{_libdir}
mv -f %{buildroot}%{_libdir}/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.py \
      %{buildroot}%{_datadir}/gdb/auto-load/%{_libdir}/
%if %isarch %{biarches}
mkdir -p %{buildroot}%{_datadir}/gdb/auto-load/%{_prefix}/lib
mv -f %{buildroot}%{_prefix}/lib/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.py \
      %{buildroot}%{_datadir}/gdb/auto-load/%{_prefix}/lib/
%endif
%endif
%endif

# fix experimental/filesystem .a location
%if %{build_libstdcxx}
mv -f %{buildroot}%{_libdir}/libstdc++fs.a %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{branch}/
%if %isarch %{biarches}
mv -f %{buildroot}%{_prefix}/lib/libstdc++fs.a %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/
%endif
%endif

# fix links broken by /usr move
rm -f %{buildroot}/lib/cpp
ln -sf %{_bindir}/cpp %{buildroot}%{_prefix}/lib/cpp

%post
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}gcc %{cross_program_prefix}gcc %{_bindir}/%{program_prefix}gcc-%{branch} %{alternative_priority}
[ -e %{_bindir}/%{cross_program_prefix}gcc ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}gcc
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}gcc-ar %{cross_program_prefix}gcc-ar %{_bindir}/%{program_prefix}gcc-ar-%{branch} %{alternative_priority}
[ -e %{_bindir}/%{cross_program_prefix}gcc-ar ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}gcc-ar
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}gcc-nm %{cross_program_prefix}gcc-nm %{_bindir}/%{program_prefix}gcc-nm-%{branch} %{alternative_priority}
[ -e %{_bindir}/%{cross_program_prefix}gcc-nm ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}gcc-nm
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}gcc-ranlib %{cross_program_prefix}gcc-ranlib %{_bindir}/%{program_prefix}gcc-ranlib-%{branch} %{alternative_priority}
[ -e %{_bindir}/%{cross_program_prefix}gcc-ranlib ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}gcc-ranlib

%postun
if [ ! -f %{_bindir}/%{cross_program_prefix}gcc-%{branch} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}gcc %{_bindir}/%{program_prefix}gcc-%{branch}
fi
if [ ! -f %{_bindir}/%{cross_program_prefix}gcc-ar-%{branch} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}gcc-ar %{_bindir}/%{program_prefix}gcc-ar-%{branch}
fi
if [ ! -f %{_bindir}/%{cross_program_prefix}gcc-nm-%{branch} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}gcc-nm %{_bindir}/%{program_prefix}gcc-nm-%{branch}
fi
if [ ! -f %{_bindir}/%{cross_program_prefix}gcc-ranlib-%{branch} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}gcc-ranlib %{_bindir}/%{program_prefix}gcc-ranlib-%{branch}
fi

%if %{build_cxx}
%post c++
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}g++ %{cross_program_prefix}g++ %{_bindir}/%{program_prefix}g++-%{branch} %{alternative_priority} --slave %{_bindir}/%{cross_program_prefix}c++ %{cross_program_prefix}c++ %{_bindir}/%{program_prefix}g++-%{branch}
[ -e %{_bindir}/%{cross_program_prefix}g++ ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}g++

%postun c++
if [ ! -f %{_bindir}/%{cross_program_prefix}g++-%{branch} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}g++ %{_bindir}/%{program_prefix}g++-%{branch}
fi
%endif

%post cpp
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}cpp %{cross_program_prefix}cpp %{_bindir}/%{program_prefix}cpp-%{branch} %{alternative_priority} --slave /lib/%{cross_program_prefix}cpp %{cross_program_prefix}lib_cpp %{_bindir}/%{program_prefix}cpp-%{branch}
[ -e %{_bindir}/%{cross_program_prefix}cpp ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}cpp

%postun cpp
if [ ! -f %{_bindir}/%{cross_program_prefix}cpp-%{branch} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}cpp %{_bindir}/%{program_prefix}cpp-%{branch}
fi

%files -f %{name}.lang
#
%doc gcc/README*
%{_mandir}/man1/%{program_prefix}gcc%{program_suffix}.1*
%if "%{name}" == "gcc%{package_suffix}"
%{_mandir}/man1/gcov%{program_suffix}.1*
%{_mandir}/man1/gcov-dump%{program_suffix}.1*
%{_mandir}/man1/gcov-tool%{program_suffix}.1*
%{_mandir}/man1/lto-dump%{program_suffix}.1*
%endif
#
%{_bindir}/%{program_prefix}gcc%{branch}-version
%{_bindir}/%{program_prefix}gcc%{program_long_suffix}
%{_bindir}/%{gcc_target_platform}-gcc%{program_suffix}
%{_bindir}/%{gcc_target_platform}-gcc-%{branch}
%{_bindir}/%{program_prefix}gcc-ar%{program_long_suffix}
%{_bindir}/%{gcc_target_platform}-gcc-ar%{program_suffix}
%{_bindir}/%{gcc_target_platform}-ar%{program_suffix}
%{_bindir}/%{gcc_target_platform}-ar-%{branch}
%{_bindir}/%{program_prefix}gcc-nm%{program_long_suffix}
%{_bindir}/%{gcc_target_platform}-gcc-nm%{program_suffix}
%{_bindir}/%{gcc_target_platform}-nm%{program_suffix}
%{_bindir}/%{gcc_target_platform}-nm-%{branch}
%{_bindir}/%{program_prefix}gcc-ranlib%{program_long_suffix}
%{_bindir}/%{gcc_target_platform}-gcc-ranlib%{program_suffix}
%{_bindir}/%{gcc_target_platform}-ranlib%{program_suffix}
%{_bindir}/%{gcc_target_platform}-ranlib-%{branch}
%if "%{name}" == "gcc%{package_suffix}"
%{_bindir}/gcov%{program_suffix}
%{_bindir}/gcov-dump%{program_suffix}
%{_bindir}/gcov-tool%{program_suffix}
%{_bindir}/lto-dump%{program_suffix}
%endif
%if %{system_compiler}
%{_bindir}/cc
%{_bindir}/c89
%{_bindir}/c99
%endif
#
%if %{libc_shared} && %{build_cross} || %{system_compiler}
%if !%{build_cross_bootstrap}
%{target_libdir}/libcc1.so
%if %isarch %arm aarch64 %{ix86} x86_64
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgcc_s.so
%else
%{target_libdir}/libgcc_s.so
%endif
%endif
%if "%{name}" == "gcc%{package_suffix}"
%if %isarch %{nof_arches}
%{_libdir}/nof/libgcc_s.so
%endif
%if %isarch %{biarches}
%{_prefix}/lib/libgcc_s.so
%{_prefix}/lib/libgcc_s_32.so
%endif
%endif
%endif
#
%dir %{gcc_libdir}/%{gcc_target_platform}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}
#
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/collect2
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/crt*.o
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgcc.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgcov.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/lto-wrapper
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/lto1
# TODO: split out?
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/liblto_plugin*
# TODO: split out
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/plugin/libcp1plugin*

%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgcc_eh.a
%if "%{name}" == "gcc%{package_suffix}"
%if %isarch %{biarches}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}/32
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/crt*.o
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libgcc.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libgcc_eh.a
%endif
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libgcov.a
%endif
%if %isarch %{nof_arches}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/crt*.o
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/ecrt*.o
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/libgcc.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/libgcc_eh.a
%endif
%endif
%endif
#
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}/include
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/float.h
# FIXME ? Fortran only ?
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/ISO_Fortran_binding.h
# FIXME ? libgomp only ?
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/acc_prof.h
%if %isarch %{ix86} x86_64
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/adxintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/ammintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avxintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx2intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx5124fmapsintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx5124vnniwintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512bitalgintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512bwintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512cdintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512dqintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512erintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512bf16intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512bf16vlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512fintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512ifmaintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512ifmavlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512pfintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vbmi2intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vbmiintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vbmi2vlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vbmivlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vlbwintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vldqintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vnniintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vnnivlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vp2intersectintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vp2intersectvlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vpopcntdqintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/avx512vpopcntdqvlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/bmiintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/bmi2intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/bmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/cet.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/cetintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/cldemoteintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/clflushoptintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/clwbintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/clzerointrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/emmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/enqcmdintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/f16cintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/fma4intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/fmaintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/fxsrintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/gfniintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/ia32intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/immintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/lwpintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/lzcntintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/mm_malloc.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/mm3dnow.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/mmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/mwaitxintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/movdirintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/nmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/pconfigintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/pkuintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/pmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/popcntintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/prfchwintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/rdseedintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/rtmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/sgxintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/shaintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/smmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/tbmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/tmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/vaesintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/vpclmulqdqintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/waitpkgintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/wbnoinvdintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/wmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/x86intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/xmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/xopintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/xsavecintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/xsaveintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/xsaveoptintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/xsavesintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/xtestintrin.h
%endif
%if %isarch %arm
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/arm_cde.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/arm_cmse.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/arm_mve.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/arm_mve_types.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/mmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/unwind-arm-common.h
%endif
%if %isarch %arm aarch64
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/arm_acle.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/arm_bf16.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/arm_fp16.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/arm_neon.h
%endif
%if %isarch aarch64
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/arm_sve.h
%endif
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/gcov.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/iso646.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/limits.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/stdalign.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/stdarg.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/stdatomic.h
%if %isarch %{ix86} x86_64
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/cross-stdarg.h
%endif
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/stdbool.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/stddef.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/stdint-gcc.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/stdint.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/stdnoreturn.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/syslimits.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/unwind.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/varargs.h
%if %isarch i386 x86_64
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/cpuid.h
%endif
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/stdfix.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/sanitizer/common_interface_defs.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/sanitizer/tsan_interface.h

%if "%{name}" == "%{cross_prefix}gcc" && %{libc_shared}
%if !%{build_monolithic}
%files -n %{libgcc_name}
%endif
%{target_libdir}/libcc1.so.%{libcc_major}
%{target_libdir}/libcc1.so.%{libcc_major}.0.0
%{target_slibdir}/libgcc_s-%{branch}.so.%{libgcc_major}
%{target_slibdir}/libgcc_s.so.%{libgcc_major}
%if %isarch %{biarches}
%{target_slibdir32}/libgcc_s-%{branch}.so.%{libgcc_major}
%{target_slibdir32}/libgcc_s.so.%{libgcc_major}
# (cg) Excluded for usrmerge
# Note: This file will be recreated when running ldconfig so it will likely
# return almost immediately on installed systems but due to a file name conflict
# when the usrmerge happens it *must* be excluded from the package.
# In the fullness of time we can remove any /lib vs /usr/lib hacks in this package.
%exclude %{_prefix}/lib/libgcc_s.so.%{libgcc_major}
%endif
%if %isarch %{nof_arches}
%{target_slibdir}/nof/libgcc_s-%{branch}.so.%{libgcc_major}
%{target_slibdir}/nof/libgcc_s.so.%{libgcc_major}
%endif
%endif

%if %{build_libssp} && %{libc_shared}
%if !%{build_monolithic}
%files -n %{libssp_name}
%endif
%{target_libdir}/libssp.so.%{libssp_major}
%{target_libdir}/libssp.so.%{libssp_major}.0.0
%if %isarch %{biarches}
%{_prefix}/lib/libssp.so.%{libssp_major}
%{_prefix}/lib/libssp.so.%{libssp_major}.0.0
%endif
%endif

%if %{build_libssp}
%if !%{build_monolithic}
%files -n %{libssp_name_orig}-devel
%endif
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/ssp
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/ssp/*.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libssp.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libssp_nonshared.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libssp.so
%endif
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libssp.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libssp_nonshared.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libssp.so
%endif
%endif
%endif

%if %{build_libgomp}
%files -n %{libgomp_name}
%{target_libdir}/libgomp.so.%{libgomp_major}
%{target_libdir}/libgomp.so.%{libgomp_major}.0.0
%if %isarch %{biarches}
%{_prefix}/lib/libgomp.so.%{libgomp_major}
%{_prefix}/lib/libgomp.so.%{libgomp_major}.0.0
%endif

%files -n %{libgomp_name_orig}-devel
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgomp.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgomp.so
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/omp.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/openacc.h
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libgomp.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libgomp.so
%endif
%{target_libdir}/libgomp.spec
%if %isarch %{biarches}
%{_prefix}/lib/libgomp.spec
%endif
%endif

%if %{build_quadmath}
%files -n %{libquadmath_name}
%{target_libdir}/libquadmath.so.%{libquadmath_major}
%{target_libdir}/libquadmath.so.%{libquadmath_major}.0.0
%if %isarch %{biarches}
%{_prefix}/lib/libquadmath.so.%{libquadmath_major}
%{_prefix}/lib/libquadmath.so.%{libquadmath_major}.0.0
%endif

%files -n %{libquadmath_name_orig}-devel
%{target_libdir}/libquadmath.a
%{target_libdir}/libquadmath.so
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/quadmath.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/quadmath_weak.h
%if %isarch %{biarches}
%{_prefix}/lib/libquadmath.a
%{_prefix}/lib/libquadmath.so
%endif
%endif

%if %{build_libitm}
%files -n %{libitm_name}
%{target_libdir}/libitm.so.%{libitm_major}
%{target_libdir}/libitm.so.%{libitm_major}.0.0
%{target_libdir}/libitm.spec
%if %isarch %{biarches}
%{_prefix}/lib/libitm.so.%{libitm_major}
%{_prefix}/lib/libitm.so.%{libitm_major}.0.0
%{_prefix}/lib/libitm.spec
%endif

%files -n %{libitm_name_orig}-devel
%{target_libdir}/libitm.a
%{target_libdir}/libitm.so
%if %isarch %{biarches}
%{_prefix}/lib/libitm.a
%{_prefix}/lib/libitm.so
%endif
%endif

%if %{build_libasan}
%files -n %{libasan_name}
%{target_libdir}/libasan.so.%{libasan_major}
%{target_libdir}/libasan.so.%{libasan_major}.0.0
%{target_libdir}/libasan_preinit.o
%if %isarch %{biarches}
%{_prefix}/lib/libasan.so.%{libasan_major}
%{_prefix}/lib/libasan.so.%{libasan_major}.0.0
%{_prefix}/lib/libasan_preinit.o
%endif

%files -n %{libasan_name_orig}-devel
%{target_libdir}/libasan.a
%{target_libdir}/libasan.so
%{target_libdir}/libsanitizer.spec
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/sanitizer/asan_interface.h
%if %isarch %{biarches}
%{_prefix}/lib/libasan.a
%{_prefix}/lib/libasan.so
%{_prefix}/lib/libsanitizer.spec
%endif
%endif

%if %{build_libatomic}
%files -n %{libatomic_name}
%{target_libdir}/libatomic.so.%{libatomic_major}
%{target_libdir}/libatomic.so.%{libatomic_major}.%{libatomic_minor}.0
%if %isarch %{biarches}
%{_prefix}/lib/libatomic.so.%{libatomic_major}
%{_prefix}/lib/libatomic.so.%{libatomic_major}.%{libatomic_minor}.0
%endif

%files -n %{libatomic_name_orig}-devel
%{target_libdir}/libatomic.a
%{target_libdir}/libatomic.so
%if %isarch %{biarches}
%{_prefix}/lib/libatomic.a
%{_prefix}/lib/libatomic.so
%endif
%endif

%if %{build_liblsan}
%files -n %{liblsan_name}
%{target_libdir}/liblsan.so.%{liblsan_major}
%{target_libdir}/liblsan.so.%{liblsan_major}.0.0
%{target_libdir}/liblsan_preinit.o

%files -n %{liblsan_name_orig}-devel
%{target_libdir}/liblsan.a
%{target_libdir}/liblsan.so
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/sanitizer/lsan_interface.h
%endif

%if %{build_libtsan}
%files -n %{libtsan_name}
%{target_libdir}/libtsan.so.%{libtsan_major}
%{target_libdir}/libtsan.so.%{libtsan_major}.0.0
%{target_libdir}/libtsan_preinit.o

%files -n %{libtsan_name_orig}-devel
%{target_libdir}/libtsan.a
%{target_libdir}/libtsan.so
%endif

%if %{build_libubsan}
%files -n %{libubsan_name}
%{target_libdir}/libubsan.so.%{libubsan_major}
%{target_libdir}/libubsan.so.%{libubsan_major}.0.0
%if %isarch %{biarches}
%{_prefix}/lib/libubsan.so.%{libubsan_major}
%{_prefix}/lib/libubsan.so.%{libubsan_major}.0.0
%endif

%files -n %{libubsan_name_orig}-devel
%{target_libdir}/libubsan.a
%{target_libdir}/libubsan.so
%if %isarch %{biarches}
%{_prefix}/lib/libubsan.a
%{_prefix}/lib/libubsan.so
%endif
%endif

%if %{build_libvtv}
%files -n %{libvtv_name}
%{target_libdir}/libvtv.so.%{libvtv_major}
%{target_libdir}/libvtv.so.%{libvtv_major}.0.0
%if %isarch %{biarches}
%{_prefix}/lib/libvtv.so.%{libvtv_major}
%{_prefix}/lib/libvtv.so.%{libvtv_major}.0.0
%endif

%files -n %{libvtv_name_orig}-devel
%{target_libdir}/libvtv.a
%{target_libdir}/libvtv.so
%if %isarch %{biarches}
%{_prefix}/lib/libvtv.a
%{_prefix}/lib/libvtv.so
%endif
%endif

%files cpp -f cpplib.lang
%{_mandir}/man1/%{program_prefix}cpp%{program_suffix}.1*
%if !%{build_cross} && %{system_compiler}
%{_prefix}/lib/%{cross_program_prefix}cpp
%endif
%ghost %{_bindir}/%{cross_program_prefix}cpp
%{_bindir}/%{program_prefix}cpp%{program_long_suffix}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/cc1

%if %{build_cxx}
%files c++ -f libstdc++.lang
%{_mandir}/man1/%{program_prefix}g++%{program_suffix}.1*
%ghost %{_bindir}/%{cross_program_prefix}c++
%{_bindir}/%{program_prefix}g++%{program_long_suffix}
%{_bindir}/%{program_prefix}c++%{program_long_suffix}
%{_bindir}/%{gcc_target_platform}-g++%{program_suffix}
%{_bindir}/%{gcc_target_platform}-c++%{program_suffix}
#
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/cc1plus
# symlinks to gcc3.4 stuff
%if !%{system_compiler}
#
%if %{build_stdcxxheaders}
%dir %{target_prefix}/include/c++
%{libstdcxx_includedir}
%endif
#
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/cxxabi.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/bits
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libstdc++.so
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libsupc++.a
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libstdc++.so
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libsupc++.a
%endif
%endif
%endif

%if %{build_libstdcxx} && %{libc_shared}
%if !%{build_monolithic}
%files -n %{libstdcxx_name}
%endif
%{target_libdir}/libstdc++.so.%{libstdcxx_major}
%{target_libdir}/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}
%if %isarch %{biarches}
%{_prefix}/lib/libstdc++.so.%{libstdcxx_major}
%{_prefix}/lib/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}
%endif
%if %isarch %{nof_arches}
%dir %{_libdir}/nof
%{_libdir}/nof/libstdc++.so.%{libstdcxx_major}
%{_libdir}/nof/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}
%endif
%endif

%if %{build_libstdcxx}
%if !%{build_monolithic}
%files -n %{libstdcxx_name_orig}-devel
%endif
%doc libstdc++-v3/README*
%dir %{libstdcxx_includedir}
%{libstdcxx_includedir}/*

%if %{system_compiler}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}/include
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/cxxabi.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/bits
%endif

%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libsupc++.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libstdc++.so
%endif
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libsupc++.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libstdc++.so
%endif
%endif
%if %isarch %{nof_arches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/libsupc++.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/libstdc++.so
%endif
%endif
%endif

%if %{build_libstdcxx}
%if !%{build_monolithic}
%files -n %{libstdcxx_name_orig}-python-devel
%endif
%dir %{python3_sitelib}/libstdcxx
%{python3_sitelib}/libstdcxx/__init__.py*
%dir %{python3_sitelib}/libstdcxx/__pycache__
%{python3_sitelib}/libstdcxx/__pycache__/__init__.cpython-*.py*
%dir %{python3_sitelib}/libstdcxx/v6
%{python3_sitelib}/libstdcxx/v6/__init__.py*
%{python3_sitelib}/libstdcxx/v6/printers.py*
%{python3_sitelib}/libstdcxx/v6/xmethods.py*
%dir %{python3_sitelib}/libstdcxx/v6/__pycache__
%{python3_sitelib}/libstdcxx/v6/__pycache__/__init__.cpython-*.py*
%{python3_sitelib}/libstdcxx/v6/__pycache__/printers.cpython-*.py*
%{python3_sitelib}/libstdcxx/v6/__pycache__/xmethods.cpython-*.py*
%if !%build_cross
%{_datadir}/gdb/auto-load/%{_libdir}/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.py*
%{_datadir}/gdb/auto-load/%{_libdir}/__pycache__/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.cpython-*.py*
%if %isarch %{biarches}
%{_datadir}/gdb/auto-load/%{_prefix}/lib/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.py*
%{_datadir}/gdb/auto-load/%{_prefix}/lib/__pycache__/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.cpython-*.py*
%endif
%endif
%endif

%if %{build_libstdcxx}
%if !%{build_monolithic}
%files -n %{libstdcxx_name_orig}-static-devel
%endif
%doc libstdc++-v3/README
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libstdc++.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libstdc++fs.a
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libstdc++.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libstdc++fs.a
%endif
%if %isarch %{nof_arches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/libstdc++.a
%endif
%endif

# placement is important in order to avoid breaking build_monolithic case
%files -n %{name}-plugins
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}/plugin/include/
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/plugin/include/*
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/plugin/gengtype
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/plugin/gtype.state
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/plugin/libcc1plugin.*

%if %{build_objc}
%files objc
%doc rpm.doc/objc/*
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/cc1obj
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libobjc.a
%if %{build_objc_gc}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libobjc_gc.a
%endif
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libobjc.so
%if %{build_objc_gc}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libobjc_gc.so
%endif
%endif
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libobjc.a
%if %{build_objc_gc}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libobjc_gc.a
%endif
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libobjc.so
%if %{build_objc_gc}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libobjc_gc.so
%endif
%endif
%endif
%if %isarch %{nof_arches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/libobjc.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/libobjc_gc.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/libobjc.so
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/libobjc_gc.so
%endif
%endif
#
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/objc
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/objc/*.h
#
%endif

%if %{build_objc} && %{libc_shared}
%if !%{build_monolithic}
%files -n %{libobjc_name}
%endif
%doc rpm.doc/libobjc/*
%doc libobjc/THREADS* libobjc/ChangeLog
%{target_libdir}/libobjc.so.%{libobjc_major}
%{target_libdir}/libobjc.so.%{libobjc_major}.0.0
%if %{build_objc_gc}
%{target_libdir}/libobjc_gc.so.%{libobjc_major}
%{target_libdir}/libobjc_gc.so.%{libobjc_major}.0.0
%endif
%if %isarch %{biarches}
%{_prefix}/lib/libobjc.so.%{libobjc_major}
%{_prefix}/lib/libobjc.so.%{libobjc_major}.0.0
%if %{build_objc_gc}
%{_prefix}/lib/libobjc_gc.so.%{libobjc_major}
%{_prefix}/lib/libobjc_gc.so.%{libobjc_major}.0.0
%endif
%endif
%endif

%if %{build_objcp}
%files objc++
%doc rpm.doc/objcp/*
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/cc1objplus
%endif

%if %{build_d}
%files gdc
%doc rpm.doc/gdc/*
%{_bindir}/%{program_prefix}gdc%{program_suffix}
%{_bindir}/%{gcc_target_platform}-gdc%{program_suffix}
%{_mandir}/man1/gdc.1*
%{_infodir}/gdc*

%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/include/d
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/d21
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgphobos.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgdruntime.a

%if %{libc_shared}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/libgdruntime.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/libgphobos.so
%if %isarch %{biarches}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/32/libgdruntime.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/32/libgphobos.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/32/libgdruntime.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/32/libgphobos.so
%endif
%if %isarch %{nof_arches}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/nof/libgdruntime.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/nof/libgphobos.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/nof/libgdruntime.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{branch}/nof/libgphobos.so
%endif
%endif
%{target_libdir}/libgphobos.spec
%if %isarch %{biarches}
%{_prefix}/lib/libgphobos.spec
%endif
%endif

%if %{build_d} && %{libc_shared}
%if !%{build_monolithic}
%files -n %{libgphobos_name}
%endif
%{target_libdir}/libgphobos.so.%{libgphobos_major}
%{target_libdir}/libgphobos.so.%{libgphobos_major}.0.0
%{target_libdir}/libgdruntime.so.%{libgphobos_major}
%{target_libdir}/libgdruntime.so.%{libgphobos_major}.0.0
%{target_libdir}/libgphobos.spec
%if %isarch %{biarches}
%{_prefix}/lib/libgphobos.so.%{libgphobos_major}
%{_prefix}/lib/libgphobos.so.%{libgphobos_major}.0.0
%{_prefix}/lib/libgdruntime.so.%{libgphobos_major}
%{_prefix}/lib/libgdruntime.so.%{libgphobos_major}.0.0
%{_prefix}/lib/libgphobos.spec
%endif
%endif

%if %{build_fortran}
%files gfortran
%doc rpm.doc/gfortran/*
%{_mandir}/man1/%{program_prefix}gfortran%{program_suffix}.1*
%{_bindir}/%{program_prefix}gfortran%{program_suffix}
%{_bindir}/%{gcc_target_platform}-gfortran%{program_suffix}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/f951
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgfortran.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libcaf_single.la
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libcaf_single.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/finclude/ieee_arithmetic.mod
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/finclude/ieee_exceptions.mod
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/finclude/ieee_features.mod

%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/libgfortran.so
%endif
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libgfortran.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libcaf_single.la
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libcaf_single.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/finclude/ieee_arithmetic.mod
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/finclude/ieee_exceptions.mod
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/finclude/ieee_features.mod
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/finclude/omp_lib.f90
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/finclude/omp_lib.h
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/finclude/omp_lib.mod
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/finclude/omp_lib_kinds.mod
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/finclude/openacc.f90
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/finclude/openacc.mod
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/finclude/openacc_kinds.mod
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/finclude/openacc_lib.h
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/libgfortran.so
%endif
%endif
%if %isarch %{nof_arches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/libgfortran.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/nof/libgfortran.so
%endif
%endif
%if %{build_libgomp}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/finclude/omp*
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/finclude/openacc*
%endif
%endif

%if %{build_fortran} && %{libc_shared}
%if !%{build_monolithic}
%files -n %{libgfortran_name}
%endif
%{target_libdir}/libgfortran.so.%{libgfortran_major}
%{target_libdir}/libgfortran.so.%{libgfortran_major}.0.0
%{target_libdir}/libgfortran.spec
%if %isarch %{biarches}
%{_prefix}/lib/libgfortran.so.%{libgfortran_major}
%{_prefix}/lib/libgfortran.so.%{libgfortran_major}.0.0
%{_prefix}/lib/libgfortran.spec
%endif
%endif

%if %{build_ada}
%files gnat
%{_bindir}/gnat*
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/32/ada_target_properties
%endif
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/ada_target_properties
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/gnat1
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}/adainclude
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adainclude/*.adb
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adainclude/*.ads
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adainclude/standard.ads.h
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}/adalib
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adalib/*.ali
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adalib/libgmem.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adalib/libgnat.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adalib/libgnat_pic.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adalib/libgnarl.a
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adalib/libgnarl_pic.a
%if %{libc_shared}
%{_libdir}/libgnat-%{libgnat_major}.so
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adalib/libgnat.so
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adalib/libgnat-%{libgnat_major}.so
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adalib/libgnarl.so
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/adalib/libgnarl-%{libgnat_major}.so
%endif
%endif

%if %{build_libffi}
%files -n %{libffi_name}
%{target_libdir}/libffi.so.%{libffi_major}
%{target_libdir}/libffi.so.%{libffi_major}.0.1
%if %isarch %{biarches}
%{_prefix}/lib/libffi.so.%{libffi_major}
%{_prefix}/lib/libffi.so.%{libffi_major}.0.1
%endif

%files -n %{libffi_name}-devel
%doc libffi/README libffi/LICENSE libffi/ChangeLog*
%{_mandir}/man3/ffi*.3*
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{branch}/include
%{gcc_libdir}/%{gcc_target_platform}/%{branch}/include/ffi*.h
%{_libdir}/libffi.a
%{_libdir}/libffi.so
%if %isarch %{biarches}
%{_prefix}/lib/libffi.a
%{_prefix}/lib/libffi.so
%endif
%endif

%if %{build_ada} && %{libc_shared}
%files -n %{libgnat_name}
%{target_libdir}/libgnat-%{libgnat_major}.so
%{target_libdir}/libgnarl-%{libgnat_major}.so
%endif

%if %{build_doc}
%files doc
%doc gcc/*ChangeLog*
%if %{build_check}
%doc test_summary.log
%endif
%{_infodir}/cppinternals%{_package_suffix}.info*
%{_infodir}/cpp%{_package_suffix}.info*
%{_infodir}/gcc%{_package_suffix}.info*
%{_infodir}/gccinstall%{_package_suffix}.info*
%{_infodir}/gccint%{_package_suffix}.info*
%if %{build_libstdcxx}
%doc rpm.doc/libstdc++/
%endif
%if %{build_cxx}
%doc rpm.doc/c++
%endif
%if %{build_libgomp}
%{_infodir}/libgomp%{_package_suffix}.info*
%endif
%if %{build_ada}
%{_infodir}/gnat-style%{_package_suffix}.info*
%{_infodir}/gnat_rm%{_package_suffix}.info*
%{_infodir}/gnat_ugn%{_package_suffix}.info*
%endif
%if %{build_fortran}
%{_infodir}/gfortran%{_package_suffix}.info*
%endif
%if %{build_quadmath}
%{_infodir}/libquadmath%{_package_suffix}.info*
%endif
%if %{build_libitm}
%{_infodir}/libitm%{_package_suffix}.info*
%endif
%endif

%if %{build_pdf_doc}
%files doc-pdf
%doc gcc/doc/cppinternals.pdf
%doc gcc/doc/gcc.pdf
%doc gcc/doc/cpp.pdf
%if %{build_ada}
%doc gcc/ada/gnat_rm.pdf
%doc gcc/ada/gnat_ugn.pdf
%endif
%if %{build_fortran}
%doc gcc/fortran/gfortran.pdf
%endif
%endif

%if %{build_libstdcxx_docs}
%files -n libstdc++-docs
%{_mandir}/man3/*
%doc rpm.doc/libstdc++-v3/html
%endif


%changelog
* Thu Apr 08 2021 tmb <tmb> 10.3.0-1.mga8
+ Revision: 1714128
- update to 10.3.0 final

* Sun Jan 31 2021 tmb <tmb> 10.2.1-0.20210130.1.mga8
+ Revision: 1674141
- update to 10.2.1 snapshot 20210130

* Sat Jan 23 2021 tmb <tmb> 10.2.1-0.20210123.1.mga8
+ Revision: 1673109
- update to 10.2.1 snapshot 20210123 for ICE fixes

* Sun Jan 10 2021 tmb <tmb> 10.2.1-0.20210109.1.mga8
+ Revision: 1670249
- update to 10.2.1 snapshot 20210109

* Sun Jan 03 2021 tmb <tmb> 10.2.1-0.20210102.1.mga8
+ Revision: 1668393
- update to 10.2.1 snapshot 20210102

* Sun Dec 27 2020 tmb <tmb> 10.2.1-0.20201226.1.mga8
+ Revision: 1664052
- update to 10.2.1 snapshot 20201226

* Sun Dec 20 2020 tmb <tmb> 10.2.1-0.20201219.1.mga8
+ Revision: 1661442
- update to 20201219 snapshot

* Sat Dec 12 2020 tmb <tmb> 10.2.1-0.20201212.1.mga8
+ Revision: 1656047
- update to 20201212 snapshot

* Mon Dec 07 2020 tmb <tmb> 10.2.1-0.20201205.1.mga8
+ Revision: 1654064
- update to 20201205 snapshot

* Mon Nov 30 2020 tmb <tmb> 10.2.1-0.20201128.1.mga8
+ Revision: 1650452
- update to 20201128 snapshot

* Sun Nov 22 2020 tmb <tmb> 10.2.1-0.20201121.2.mga8
+ Revision: 1648378
- testbuild with glibc 2.32

* Sun Nov 22 2020 tmb <tmb> 10.2.1-0.20201121.1.mga8
+ Revision: 1648376
- update to 20201121 snapshot

* Wed Nov 18 2020 pterjan <pterjan> 10.2.1-0.20201114.1.mga8
+ Revision: 1647104
- Update to 20201114 snapshot
- Fix building non RC snapshots
+ tv <tv>
- make gcc-c++ requires libgomp-devel, thus fixing building mdds & the like

* Sat Aug 01 2020 ghibo <ghibo> 10.2.0-2.mga8
+ Revision: 1610356
- Add patch for fixing upstream bug https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96377

* Thu Jul 23 2020 kekepower <kekepower> 10.2.0-1.mga8
+ Revision: 1608578
- Update to version 10.2.0 Final

* Tue Jul 21 2020 kekepower <kekepower> 10.2.0-0.RC.1.mga8
+ Revision: 1607595
- Update to version 10.2RC - 20200715

* Sun Jul 12 2020 kekepower <kekepower> 10.1.1-0.20200711.1.mga8
+ Revision: 1605484
- Update to 10.1.1 snapshot 20200711

* Sun Jul 05 2020 kekepower <kekepower> 10.1.1-0.20200704.1.mga8
+ Revision: 1602349
- Update to 10.1.1 snapshot 20200704

* Thu Jul 02 2020 kekepower <kekepower> 10.1.1-0.20200627.1.mga8
+ Revision: 1601322
- Update to 10.1.1 snapshot 20200627

* Sun Jun 21 2020 kekepower <kekepower> 10.1.1-0.20200620.1.mga8
+ Revision: 1598356
- Update to 10.1.1 snapshot 20200620

* Thu Jun 18 2020 kekepower <kekepower> 10.1.1-0.20200613.2.mga8
+ Revision: 1595874
- Add upstream staging patches

* Sun Jun 14 2020 kekepower <kekepower> 10.1.1-0.20200613.1.mga8
+ Revision: 1593287
- Update to 10.1.1 snapshot 20200613

* Tue Jun 09 2020 kekepower <kekepower> 10.1.1-0.20200606.1.mga8
+ Revision: 1591546
- Update to 10.1.1 snapshot 20200606

* Sun May 24 2020 tmb <tmb> 10.1.1-0.20200523.1.mga8
+ Revision: 1587196
- update to 10.1.1 snapshot 20200523

* Sun May 17 2020 tmb <tmb> 10.1.0-5.mga8
+ Revision: 1585743
- Update cpplib sv.po
- d: Fix ICE in verify_gimple_stmt, at tree-cfg.c:4959
- libphobos: Backport library fixes from mainline

* Fri May 15 2020 tmb <tmb> 10.1.0-4.mga8
+ Revision: 1583750
- coroutines: Update TREE_SIDE_EFFECTS on inserted bind exprs
- Fix typo in fprofile-prefix-path
- RTEMS: Improve GCC specification
- Fortran : Spurious warning message with -Wsurprising [PR 59107]
- Update gcc .po files
- syscall: append to environment in tests, don't clobber it [PR 95061]
- libstdc++: Make byte-sized std::fill_n a constant expression [PR 94933]
- libstdc++: Fix incorrect size calculation in PMR resource  [PR 94906]
- Fortran: Fix/modify present() handling for assumed-shape optional [PR 94672]
- testsuite/92177 - adjust expected patterns for gcc.dg/vect/bb-slp-22.c
- ipa/94947 - fix test for externally visible variables for IPA PTA
- ipa/94947 - avoid using externally_visible_p ()
- Fortran: ICE in gfc_conv_array_constructor_expr [PR 93497]

* Sat May 09 2020 tmb <tmb> 10.1.0-3.mga8
+ Revision: 1581977
- tree: Avoid variable sharing in get_narrower [PR 94724]
- c++: Parenthesized-init of aggregates accepts invalid code [PR 94885]

* Thu May 07 2020 tmb <tmb> 10.1.0-2.mga8
+ Revision: 1581602
- c: Fix ICE with _Atomic side-effect in nested fn param decls [PR 94842]
- diagnostics: get_option_html_page fixes
- x86: Fix *vec_dupv4hi constraints [PR 94942]
- combine: Don't replace SET_SRC with REG_EQUAL note content if SET_SRC
  has side-effects [PR 94873]
- c++: Don't synthesize sfk_comparison method multiple times [PR 94907]
- c++: Avoid strict_aliasing_warning on dependent types or expressions
  [PR 94951]
- c-family: Fix error-recovery ICE on __builtin_speculation_safe_value
  [PR 94968]
- testsuite: Improve g++.dg/ext/attr-parm-1.C testcase [PR 94946]
- Fix optindex entries for 2 options
- c++: ICE in value_dependent_expression_p in C++98 mode [PR 94938]
- libstdc++: Replace deduced return type in ranges::iter_move [PR 92894]

* Thu May 07 2020 tmb <tmb> 10.1.0-1.mga8
+ Revision: 1581489
- update to 10.1.0 final

* Tue May 05 2020 tmb <tmb> 10.1.0-0.RC.9.mga8
+ Revision: 1580429
- internal-fn: Avoid dropping the lhs of some calls [PR94941]
- Revert "tree: Don't reuse types if TYPE_USER_ALIGN differ [PR94775]"

* Mon May 04 2020 tmb <tmb> 10.1.0-0.RC.8.mga8
+ Revision: 1579622
- document effective target fileio
- libstdc++: Replace reserved identifier _T with _Tp [PR 94901]
- tilegx: Unbreak build

* Sun May 03 2020 tmb <tmb> 10.1.0-0.RC.6.mga8
+ Revision: 1578278
- BR: zstd-devel for Zstd LTO Bytecode Compression Support
- add gdc support (mga#26577)
- fix libasan upgrade

* Fri May 01 2020 tmb <tmb> 10.1.0-0.RC.4.mga8
+ Revision: 1577656
- update arm and aarch64 filelists
- update filelists
- libgnat major is now 10, libasan major is now 6
- disable multithreaded rpmbuild for now
- rebase P201-P203
- update to 10.1-RC

* Thu Mar 12 2020 tmb <tmb> 9.3.0-1.mga8
+ Revision: 1555857
- update to 9.3.0 final

* Sun Mar 08 2020 tmb <tmb> 9.3.0-0.RC.2.mga8
+ Revision: 1554927
- switch to gcc major version only in install paths (--with-gcc-major-version-only)

* Sun Mar 08 2020 tmb <tmb> 9.3.0-0.RC.1.mga8
+ Revision: 1554778
- update to 9.3.0 RC

* Sun Mar 01 2020 tmb <tmb> 9.2.1-0.20200229.1.mga8
+ Revision: 1552494
- update to 9.2.1 snapshot 20200229
- update to 9.2.1 snapshot 20200229

* Sun Feb 23 2020 tmb <tmb> 9.2.1-0.20200222.1.mga8
+ Revision: 1549612
- update to 9.2.1 snapshot 20200222

* Thu Feb 20 2020 umeabot <umeabot> 9.2.1-0.20200215.2.mga8
+ Revision: 1547380
- Mageia 8 Mass Rebuild

* Sun Feb 16 2020 tmb <tmb> 9.2.1-0.20200215.1.mga8
+ Revision: 1529475
- update to 9.2.1 snapshot 20200215

* Sun Feb 09 2020 tmb <tmb> 9.2.1-0.20200208.1.mga8
+ Revision: 1488091
- update to 9.2.1 snapshot 20200208

* Sun Feb 02 2020 tmb <tmb> 9.2.1-0.20200201.1.mga8
+ Revision: 1486407
- update to 9.2.1 snapshot 20200201

* Sun Jan 26 2020 tmb <tmb> 9.2.1-0.20200125.1.mga8
+ Revision: 1483146
- update to 9.2.1 snapshot 20200125

* Sun Jan 19 2020 tmb <tmb> 9.2.1-0.20200118.1.mga8
+ Revision: 1481463
- update to 9.2.1 snapshot 20200118

* Sun Jan 12 2020 tmb <tmb> 9.2.1-0.20200111.1.mga8
+ Revision: 1477628
- update to 9.2.1 snapshot 20200111

* Sun Jan 05 2020 tmb <tmb> 9.2.1-0.20200104.1.mga8
+ Revision: 1476612
- update to 9.2.1 snapshot 20200104

* Sun Dec 29 2019 tmb <tmb> 9.2.1-0.20191228.1.mga8
+ Revision: 1474689
- update to 9.2.1 snapshot 20191228
+ wally <wally>
- replace deprecated %%makeinstall_std

* Sun Dec 22 2019 tmb <tmb> 9.2.1-0.20191221.1.mga8
+ Revision: 1469459
- update to 9.2.1 snapshot 20191221

* Sat Dec 14 2019 tmb <tmb> 9.2.1-0.20191214.1.mga8
+ Revision: 1467238
- update to 9.2.1 snapshot 20191214

* Sun Dec 08 2019 tmb <tmb> 9.2.1-0.20191207.1.mga8
+ Revision: 1465064
- update to 9.2.1 snapshot 20191207

* Sun Dec 01 2019 tmb <tmb> 9.2.1-0.20191130.1.mga8
+ Revision: 1463900
- update to 9.2.1 snapshot 20191130

* Sat Nov 23 2019 tmb <tmb> 9.2.1-0.20191123.1.mga8
+ Revision: 1462531
- update to 9.2.1 snapshot 20191123

* Mon Nov 18 2019 tmb <tmb> 9.2.1-0.20191116.1.mga8
+ Revision: 1461683
- update to 9.2.1 snapshot 20191116

* Sun Nov 10 2019 tmb <tmb> 9.2.1-0.20191109.1.mga8
+ Revision: 1458978
- update to 9.2.1 snapshot 20191109

* Sun Nov 03 2019 tmb <tmb> 9.2.1-0.20191102.1.mga8
+ Revision: 1457413
- update to 9.2.1 snapshot 20191102

* Sun Oct 27 2019 tmb <tmb> 9.2.1-0.20191026.1.mga8
+ Revision: 1455984
- update to 9.2.1 snapshot 20191026

* Sun Oct 20 2019 tmb <tmb> 9.2.1-0.20191019.1.mga8
+ Revision: 1454673
- update to 9.2.1 snapshot 20191019

* Sun Oct 13 2019 tmb <tmb> 9.2.1-0.20191012.1.mga8
+ Revision: 1452448
- update to 9.2.1 snapshot 20191012

* Sun Oct 06 2019 tmb <tmb> 9.2.1-0.20191005.1.mga8
+ Revision: 1449784
- update to 9.2.1 snapshot 20191005

* Sun Sep 29 2019 tmb <tmb> 9.2.1-0.20190928.1.mga8
+ Revision: 1447901
- update to 9.2.1 snapshot 20190928

* Mon Sep 23 2019 tmb <tmb> 9.2.1-0.20190921.1.mga8
+ Revision: 1444747
- update to 9.2.1 snapshot 20190921

* Sun Sep 15 2019 tmb <tmb> 9.2.1-0.20190914.1.mga8
+ Revision: 1441009
- update filelists
- update to 9.2.1 snapshot 20190914

* Mon Sep 09 2019 tmb <tmb> 9.2.1-0.20190907.0.1.mga8
+ Revision: 1438588
- update filelist
- update to 9.2.1 snapshot 20190907

* Mon Sep 02 2019 tmb <tmb> 9.2.1-0.20190831.3.mga8
+ Revision: 1436489
- libstdc++-devel: split out python stuff to libstdc++-python-devel
  to break python dependency loop

* Sun Sep 01 2019 tmb <tmb> 9.2.1-0.20190831.2.mga8
+ Revision: 1436134
- really fix filelists
- libstdc++ micro is now 28
- update to 9.2.1 snapshot 20190831
+ tv <tv>
- fix file list

* Fri Aug 30 2019 tv <tv> 9.2.0-2.mga8
+ Revision: 1435312
- fix file list
- gcc cannot buildconflicts with python b/c libstdc++-devel requires it...
+ tmb <tmb>
- switch to python3

* Mon Aug 12 2019 tmb <tmb> 9.2.0-1.mga8
+ Revision: 1428905
- update to 9.2.0 final
- PR c++/91378 - ICE with noexcept and auto return type
- fix filelist for armv7hl

* Wed Aug 07 2019 tv <tv> 9.2.0-0.RC.1.mga8
+ Revision: 1427870
- fix filelist on aarch64
+ tmb <tmb>
- PR c++/90947 - Simple lookup table of array of strings is miscompiled
- update to 9.2 RC
  * drop merged patches
  * libgnat major is now 9
  * libstdc++ micro is now 27
  * Intel MPX support has been dropped
  * update filelists

* Sat Aug 03 2019 tmb <tmb> 8.3.1-0.20190802.1.mga8
+ Revision: 1426978
- update to 8.3.1 snapshot 20190802

* Sat Jul 27 2019 tmb <tmb> 8.3.1-0.20190726.1.mga8
+ Revision: 1424458
- update to 8.3.1 snapshot 20190726

* Sat Jul 20 2019 tmb <tmb> 8.3.1-0.20190719.1.mga8
+ Revision: 1423046
- update to 8.3.1 snapshot 20190719

* Sat Jul 13 2019 tmb <tmb> 8.3.1-0.20190712.1.mga8
+ Revision: 1420998
- update to 8.3.1 snapshot 20190712

* Sat Jul 06 2019 tmb <tmb> 8.3.1-0.20190705.1.mga8
+ Revision: 1418859
- update to 8.3.1 snapshot 20190705
- PR middle-end/90139 : tree-outof-ssa.c,  (get_temp_reg): If reg_mode
  is BLKmode, return assign_temp instead of gen_reg_rtx.

* Thu Jul 04 2019 tmb <tmb> 8.3.1-0.20190628.2.mga8
+ Revision: 1418523
- PR rtl-optimization/90756: explow.c (promote_ssa_mode): Always use
  TYPE_MODE, don't bypass it for VECTOR_TYPE_P

* Sat Jun 29 2019 tmb <tmb> 8.3.1-0.20190628.1.mga8
+ Revision: 1415590
- update to 8.3.1 snapshot 20190628

* Sat May 25 2019 tmb <tmb> 8.3.1-0.20190524.1.mga7
+ Revision: 1399083
- update to 8.3.1 snapshot 20190524

* Sat May 18 2019 tmb <tmb> 8.3.1-0.20190517.1.mga7
+ Revision: 1398259
- update to 8.3.1 snapshot 20190517

* Sat May 11 2019 tmb <tmb> 8.3.1-0.20190510.1.mga7
+ Revision: 1397191
- update to 8.3.1 snapshot 20190510

* Sat May 04 2019 tmb <tmb> 8.3.1-0.20190503.1.mga7
+ Revision: 1396328
- update to 8.3.1 snapshot 2019-05-03

* Sat Apr 20 2019 tmb <tmb> 8.3.1-0.20190419.2.mga7
+ Revision: 1394141
- rebuild for arm

* Sat Apr 20 2019 tmb <tmb> 8.3.1-0.20190419.1.mga7
+ Revision: 1394046
- update to 8.3.1 snapshot 2019-04-19

* Sat Apr 13 2019 tmb <tmb> 8.3.1-0.20190412.1.mga7
+ Revision: 1389667
- update to 8.3.1 snapshoy 2019-04-12

* Sat Apr 06 2019 tmb <tmb> 8.3.1-0.20190405.1.mga7
+ Revision: 1386351
- update to 8.3.1 snapshot 2019-04-05

* Sat Mar 30 2019 tmb <tmb> 8.3.1-0.20190329.1.mga7
+ Revision: 1381447
- update to 8.3.1 snapshot 2019-03-29

* Sat Mar 23 2019 tmb <tmb> 8.3.1-0.20190322.1.mga7
+ Revision: 1379711
- update to 8.3.1 snapshot 2019-03-22

* Fri Mar 15 2019 tmb <tmb> 8.3.1-0.20190315.1.mga7
+ Revision: 1377756
- update to 8.3.1 snapshot 2019-03-15

* Tue Mar 12 2019 tmb <tmb> 8.3.1-0.20190308.1.mga7
+ Revision: 1374655
- add more fixes from upstream gcc-8 branch
- update to 8.3.1 snapshot 2019-03-08

* Fri Mar 01 2019 tmb <tmb> 8.3.0-5.mga7
+ Revision: 1370755
- AArch64: Make every option in options.def one line (GCC-8)

* Wed Feb 27 2019 tmb <tmb> 8.3.0-4.mga7
+ Revision: 1370385
- PR target/89397: config/i386/i386.c:  Check TARGET_SSE in addition
  to TARGET_SSE_MATH.

* Tue Feb 26 2019 tmb <tmb> 8.3.0-3.mga7
+ Revision: 1370289
- PR c++/89212 - ICE converting nullptr to pointer-to-member-function

* Sat Feb 23 2019 tmb <tmb> 8.3.0-2.mga7
+ Revision: 1369579
- PR libstdc++/89446: fix null pointer dereference in char_traits

* Fri Feb 22 2019 tmb <tmb> 8.3.0-1.mga7
+ Revision: 1369362
- update to 8.3.0 final

* Fri Feb 15 2019 tmb <tmb> 8.3.0-0.RC.1.mga7
+ Revision: 1367461
- update to 8.3.0-RC

* Sat Feb 09 2019 tmb <tmb> 8.2.1-0.20190208.1.mga7
+ Revision: 1364364
- drop asm backport revert
- update to 8.2.1 snapshot 2019-02-08

* Thu Feb 07 2019 tmb <tmb> 8.2.1-0.20190201.2.mga7
+ Revision: 1363908
- rebuild with new binutils

* Sat Feb 02 2019 tmb <tmb> 8.2.1-0.20190201.1.mga7
+ Revision: 1362321
- update to 8.2.1 snapshot 2019-02-01

* Tue Jan 22 2019 luigiwalser <luigiwalser> 8.2.1-0.20190118.2.mga7
+ Revision: 1359163
- rebuild for isl

* Sat Jan 19 2019 tmb <tmb> 8.2.1-0.20190118.1.mga7
+ Revision: 1358004
- update to 8.2.1 snapshot 2019-01-18

* Sun Jan 13 2019 tmb <tmb> 8.2.1-0.20190111.1.mga7
+ Revision: 1355908
- rebase asm revert
- update to 8.2.1 snapshot 2019-01-11

* Tue Jan 08 2019 tmb <tmb> 8.2.1-0.20190104.2.mga7
+ Revision: 1352696
- revert upstream 'Backport of the "asm inline" patches' for now as it
  breaks atleast virtualbox builds

* Sat Jan 05 2019 tmb <tmb> 8.2.1-0.20190104.1.mga7
+ Revision: 1349902
- update to 8.2.1 snapshot 2019-01-04

* Sat Dec 29 2018 tmb <tmb> 8.2.1-0.20181228.1.mga7
+ Revision: 1346228
- update to gcc 8.2.1 snapshot 2018-12-28

* Sat Dec 22 2018 tmb <tmb> 8.2.1-0.20181221.1.mga7
+ Revision: 1344348
- update to 8.2.1 snapshot 2018-12-21

* Sat Dec 15 2018 tmb <tmb> 8.2.1-0.20181214.1.mga7
+ Revision: 1341404
- update to gcc 8.2.1 snapshot 2018-12-14

* Fri Dec 07 2018 tmb <tmb> 8.2.1-0.20181207.1.mga7
+ Revision: 1338862
- update to 8.2.1 snapshot 2018-12-07

* Fri Nov 30 2018 tmb <tmb> 8.2.1-0.20181130.1.mga7
+ Revision: 1336970
- update to 8.2.1 snapshot 2018-11-30

* Sat Nov 24 2018 tmb <tmb> 8.2.1-0.20181123.1.mga7
+ Revision: 1333699
- update to 8.2.1 snapshot 2018-11-23

* Thu Nov 22 2018 tmb <tmb> 8.2.1-0.20181116.2.mga7
+ Revision: 1333306
- PR target/87928: config/i386/i386.h (STACK_BOUNDARY): Use TARGET_64BIT_MS_ABI
- PR gcov-profile/88045: workaround call to std::accumulate causes gcov to crash
- PR rtl-optimization/85925: compilation of masking goes wrong in combine at -02
- PR lto/88077: ICE: tree check: expected class ‘type’, have ‘declaration’

* Sat Nov 17 2018 tmb <tmb> 8.2.1-0.20181116.1.mga7
+ Revision: 1330290
- update to 8.2.1 snapshot 2018-11-16

* Sat Nov 10 2018 tmb <tmb> 8.2.1-0.20181109.1.mga7
+ Revision: 1329245
- update to 8.2.1 snapshot 2018-11-09

* Sat Nov 03 2018 tmb <tmb> 8.2.1-0.20181102.1.mga7
+ Revision: 1327987
- update to 8.2.1 snapshot 2018-11-02

* Sat Oct 27 2018 tmb <tmb> 8.2.1-0.20181026.1.mga7
+ Revision: 1326153
- update to 8.2.1 snapshot 2018-10-26

* Sat Oct 20 2018 tmb <tmb> 8.2.1-0.20181019.1.mga7
+ Revision: 1322931
- update to 8.2.1 snapshot 20181019

* Sat Oct 13 2018 tmb <tmb> 8.2.1-0.20181012.1.mga7
+ Revision: 1320043
- update to 8.2.1 snapshot 20181012

* Sat Oct 06 2018 tmb <tmb> 8.2.1-0.20181005.1.mga7
+ Revision: 1318087
- update to 8.2.1 snapshot 2018-10-05

* Sat Sep 29 2018 tmb <tmb> 8.2.1-0.20180928.1.mga7
+ Revision: 1311643
- update to 8.2.1 snapshot 20180928

* Sat Sep 22 2018 tmb <tmb> 8.2.1-0.20180921.1.mga7
+ Revision: 1296579
- update to 8.2.1 snapshot 20180921

* Sat Sep 15 2018 tmb <tmb> 8.2.1-0.20180914.1.mga7
+ Revision: 1258980
- update to 8.2.1 snapshot 20180914

* Tue Sep 11 2018 tmb <tmb> 8.2.1-0.20180907.2.mga7
+ Revision: 1258414
- PR libstdc++/87278 restore support for std::make_shared<volatile T>()

* Sat Sep 08 2018 tmb <tmb> 8.2.1-0.20180907.1.mga7
+ Revision: 1257744
- update to 8.2.1 snapshot 20180907
+ tv <tv>
- rely on filetriggers for info system (mga#23482)

* Sat Sep 01 2018 tmb <tmb> 8.2.1-0.20180831.2.mga7
+ Revision: 1256056
- update to 8.2.1 snapshot 20180831

* Tue Aug 28 2018 tmb <tmb> 8.2.1-0.20180824.2.mga7
+ Revision: 1255249
- PR target/86662: msp430-elf segfault with -flto and -mlarge
- PR libfortran/86704: Segmentation fault when using matmul in combination with transpose
- PR rtl-optimization/87065: combine causes ICE in trunc_int_for_mode

* Sat Aug 25 2018 tmb <tmb> 8.2.1-0.20180824.1.mga7
+ Revision: 1253906
- update to 8.2.1 - 20180824 snapshot

* Sat Aug 18 2018 tmb <tmb> 8.2.1-0.20180817.1.mga7
+ Revision: 1252391
- update to 8.2.1 snapshot 20180817

* Sat Aug 11 2018 tmb <tmb> 8.2.1-0.20180810.2.mga7
+ Revision: 1251096
- PR c++/86728 - C variadic generic lambda

* Sat Aug 11 2018 tmb <tmb> 8.2.1-0.20180810.1.mga7
+ Revision: 1250986
- update to 8.2.1 snapshot 2018-08-10

* Sat Aug 04 2018 tmb <tmb> 8.2.1-0.20180803.1.mga7
+ Revision: 1247200
- update to 8.2.1 snapshot 2018-08-03

* Thu Aug 02 2018 tv <tv> 8.2.1-0.20180727.3.mga7
+ Revision: 1246921
- further fix upgrade

* Thu Aug 02 2018 tv <tv> 8.2.1-0.20180727.2.mga7
+ Revision: 1246852
- fix upgrade

* Sat Jul 28 2018 tmb <tmb> 8.2.1-0.20180727.1.mga7
+ Revision: 1245664
- update to 8.2.1 snapshot 20180727
- drop some obsolete manbo stuff
- fix url and source url
- Obsolete libcilkrts packages

* Fri Jul 27 2018 tmb <tmb> 8.2.0-0.5.mga7
+ Revision: 1245541
- update filelists
- libgnat major is now 8
- drop old Ada Makefile hack
- libstdc++ micro is now 25
- libgfortran major is now 5
- libasan major is now 5
- libubsan major is now 1
- fix typos
- Cilk+ is removed upstream
- drop unused mips stuff
- drom ancient lsb hacks
- rebase and reorder mageia patches
- pass --with-linker-hash-style=gnu to build instead of patching it
- rebase linux32 patch
- drop merged / obsolete patches
- update to 8.2.0

* Tue Jul 24 2018 tmb <tmb> 7.3.0-8.mga7
+ Revision: 1245050
- rebuild with binutils 2.31.1-2.mga7

* Sat Jul 21 2018 tmb <tmb> 7.3.0-6.mga7
+ Revision: 1244751
- testbuild with new binutils

* Sat May 26 2018 tmb <tmb> 7.3.0-5.mga7
+ Revision: 1232301
- rebuild with new optflags
- rebuild with new glibc
+ wally <wally>
- add aarch64 support
- add a patch from Fedora to always emit DWARF-2 unwind info on aarch64

* Tue Feb 20 2018 tmb <tmb> 7.3.0-3.mga7
+ Revision: 1203499
- backport PR C++/80654: Implement new C++ intrinsics __is_assignable
  and __is_constructible. (requested on dev@ by Christiaan Welvaart)

* Mon Feb 19 2018 kekepower <kekepower> 7.3.0-2.mga7
+ Revision: 1202945
- Rebuild for new mpfr

* Thu Jan 25 2018 tmb <tmb> 7.3.0-1.mga7
+ Revision: 1197178
- update to 7.3.0 final

* Mon Jan 22 2018 tmb <tmb> 7.3.0-0.rc.20180122.1.mga7
+ Revision: 1196301
- update to 7.3.0 rc2

* Thu Jan 18 2018 tmb <tmb> 7.3.0-0.rc.20180117.1.mga7
+ Revision: 1194281
- update to 7.3.0 RC

* Sat Dec 23 2017 tmb <tmb> 7.2.2-20171221.1.mga7
+ Revision: 1184244
- update to 20171221 snapshot

* Fri Dec 08 2017 tmb <tmb> 7.2.2-20171207.1.mga7
+ Revision: 1181736
- update to 2017-12-07 snapshot

* Mon Dec 04 2017 tmb <tmb> 7.2.2-20171130.1.mga7
+ Revision: 1181243
- rebuild against re-bootstrapped gcc
- try to disable bootstrap
- update to 2017-11-30 snapshot
- updat to 2017-11-02 snapshot
- update to 20170709 snapshot

* Fri Sep 01 2017 tmb <tmb> 7.2.1-20170831.1.mga7
+ Revision: 1150374
- rebuild with binutils-2.29.0-5.mga7
- update to 20180831 snapshot

* Sun Aug 27 2017 tmb <tmb> 7.2.1-1.mga7
+ Revision: 1148281
- update to 7.2.1 snapshot 2017-08-24
- rebuild with new binutils
- update to 7.2.0 final
- update filelist for arm

* Sun Aug 13 2017 tmb <tmb> 7.2.0-0.RC.1.mga7
+ Revision: 1140050
- force build with new binutils 2.29
- update filelists and devel provides for libgcc_s
- temporaily disable libvtv
- update filelists
- drop obsolete revert
- fix missing endif
- BR gcc-c++ as its mandatory to build gcc
- ensure BASE-VER always matches rpm version
- add libmpx packages
- libgfortran major is now 4
- libasan major is now 4
- libatomic minor is now 2
- rebase ada makefile fix
- update to second RC
- drop obsolete patches
- spec cleanups
- rebase P107 (pass libdir around)
- rebase P115 (linux32 suport), P211 (hash-style gnu)
- allow disabling of objc-gc
- libstdcxx micro is now 24
- bye-bye gpc
- bye-bye java
- update to 7.2 RC

* Sat Jul 01 2017 tmb <tmb> 5.4.0-5.mga6
+ Revision: 1108810
- add Mageia branding (requested by Remi on dev@ ml)

* Sat May 13 2017 tmb <tmb> 5.4.0-4.mga6
+ Revision: 1100979
- more miscompilation and ICE fixes from upstream gcc-5 branch

* Wed Apr 26 2017 tmb <tmb> 5.4.0-3.mga6
+ Revision: 1097540
- more fixes from upstream gcc-5 branch

* Sun Mar 26 2017 tmb <tmb> 5.4.0-2.mga6
+ Revision: 1094890
- add regression, miscompilation and ICE fixes from upstream gcc-5 branch
- Support exception propagation without lock-free atomic int

* Fri Jun 03 2016 tmb <tmb> 5.4.0-1.mga6
+ Revision: 1020173
- update to 5.4.0 final

* Sun May 29 2016 tmb <tmb> 5.4.0-0.RC.1.mga6
+ Revision: 1019344
- update to 5.4.0-RC
+ tv <tv>
- fix error on uninstalling gcc-doc

* Thu May 05 2016 tmb <tmb> 5.3.1-0.20160503.1.mga6
+ Revision: 1009624
- update to 2016-05-03 snapshot

* Wed Apr 20 2016 tmb <tmb> 5.3.1-0.20160419.1.mga6
+ Revision: 1003817
- update to 2016-04-19
+ pterjan <pterjan>
- Add flags for armv7hl

* Wed Apr 06 2016 tmb <tmb> 5.3.1-0.20160405.1.mga6
+ Revision: 999024
- update to 2016-04-05

* Thu Mar 24 2016 tmb <tmb> 5.3.1-0.20160322.1.mga6
+ Revision: 994763
- update to 2016-03-22

* Thu Mar 17 2016 tmb <tmb> 5.3.1-0.20160315.2.mga6
+ Revision: 992428
- fix PR c++/70209: ICE in strip_typedefs (mga#17949)

* Wed Mar 16 2016 tmb <tmb> 5.3.1-0.20160315.1.mga6
+ Revision: 992202
- update to 2016-03-15 snapshot

* Tue Mar 15 2016 tmb <tmb> 5.3.1-0.20160308.1.mga6
+ Revision: 991066
- update to 2016-03-08 snapshot

* Mon Mar 07 2016 cjw <cjw> 5.3.1-0.20160301.3.mga6
+ Revision: 986986
- fix dependency on libecj-java since this provides was dropped from ecj
- make libatomic-devel depend on libatomic

* Sun Mar 06 2016 pterjan <pterjan> 5.3.1-0.20160301.2.mga6
+ Revision: 986561
- Enable ada on arm

* Thu Mar 03 2016 tmb <tmb> 5.3.1-0.20160301.1.mga6
+ Revision: 984393
- update to 2016-03-01
+ neoclust <neoclust>
- Enable java on arm

* Fri Feb 26 2016 tmb <tmb> 5.3.1-0.20160223.1.mga6
+ Revision: 979672
- update to 2016-02-23

* Thu Jan 28 2016 tmb <tmb> 5.3.1-0.20160126.1.mga6
+ Revision: 928448
- update to 2015-01-26 snapshot

* Sun Jan 24 2016 luigiwalser <luigiwalser> 5.3.1-0.20160112.3.mga6
+ Revision: 926994
- rebuild for real this time

* Sun Jan 24 2016 luigiwalser <luigiwalser> 5.3.1-0.20160112.2.mga6
+ Revision: 926937
- rebuild for isl

* Wed Jan 13 2016 tmb <tmb> 5.3.1-0.20160112.1.mga6
+ Revision: 922843
- update to 2016-01-12

* Wed Jan 06 2016 tmb <tmb> 5.3.1-0.20160105.1.mga6
+ Revision: 919920
- update to 2016-01-05 snapshot

* Wed Dec 23 2015 tmb <tmb> 5.3.1-0.20151222.1.mga6
+ Revision: 913712
- update to 5.3.1 snapshot 2015-12-22

* Sun Dec 06 2015 tmb <tmb> 5.3.0-2.mga6
+ Revision: 908488
- fix PR lto/(65948/66027): ICE in odr_types_equivalent_p
- fix PR c++/67337: segfault in mangle.c

* Fri Dec 04 2015 tmb <tmb> 5.3.0-1.mga6
+ Revision: 908104
- update to 5.3.0 final

* Sun Nov 29 2015 tmb <tmb> 5.2.1-0.20151124.1.mga6
+ Revision: 907029
- update to 2015-11-24

* Wed Nov 11 2015 tmb <tmb> 5.2.1-0.20151110.1.mga6
+ Revision: 901570
- update to 2015-11-10 snapshot

* Wed Nov 04 2015 tmb <tmb> 5.2.1-0.20151103.1.mga6
+ Revision: 897831
- update to 2015-11-03

* Wed Oct 21 2015 tmb <tmb> 5.2.1-0.20151020.1.mga6
+ Revision: 894012
- update to 2015-10-20 snapshot

* Wed Oct 14 2015 tmb <tmb> 5.2.1-0.20151013.1.mga6
+ Revision: 890766
- update to 2015-10-13 snapshot

* Wed Sep 23 2015 tmb <tmb> 5.2.1-0.20150922.1.mga6
+ Revision: 882437
- update to 2015-09-22 snapshot

* Tue Sep 08 2015 blino <blino> 5.2.1-0.20150811.6.mga6
+ Revision: 874027
- package arm_acle.h on ARM
- package stdalign/stdatomic/stdnoreturn headers for all archs (stdatomic was not included on ARM)
- package openacc.h in gomp devel package, and not only for x86 (built on ARM as well)
- package libcc1.so for ARM as well
- build vtv only on i?86 and x86_64, unsupported otherwise (e.g. on ARM)

* Mon Sep 07 2015 blino <blino> 5.2.1-0.20150811.5.mga6
+ Revision: 873840
- fix prep without java (for arm/mips)

* Mon Aug 24 2015 blino <blino> 5.2.1-0.20150811.4.mga6
+ Revision: 869029
- remove incorrect obsoletes/provides for libstdc++5

* Thu Aug 20 2015 tmb <tmb> 5.2.1-0.20150811.3.mga6
+ Revision: 866934
- submit to /release

* Thu Aug 20 2015 tmb <tmb> 5.2.1-0.20150811.2.mga6
+ Revision: 866038
- cloog and ppl has been replaced by isl for Graphite support

* Wed Aug 19 2015 tmb <tmb> 5.2.1-0.20150811.1.mga6
+ Revision: 866002
- update to 5.2.1 snapshot 2015-08-11
  * see: https://gcc.gnu.org/gcc-5/changes.html
  * libstdcxx micro is now 21
  * libgcj major is now 16
  * libasan major is now 2
  * disable broken pdf build
  * update filelists

* Tue Aug 18 2015 tmb <tmb> 4.9.2-8.mga6
+ Revision: 865414
- rebuild with fixed glibc
- rebuild with new glibc

* Sun Aug 02 2015 tmb <tmb> 4.9.2-6.mga6
+ Revision: 860856
- rebuild with new binutils

* Fri Jul 31 2015 tmb <tmb> 4.9.2-5.mga6
+ Revision: 860179
- testbuild with new binutils

* Sun Nov 02 2014 cjw <cjw> 4.9.2-4.mga5
+ Revision: 795243
- source9/patch133: add java.security classes from apache harmony to libgcj to fix networking with bouncycastle 1.50

* Thu Oct 30 2014 tmb <tmb> 4.9.2-3.mga5
+ Revision: 794707
- update to 4.9.2 final

* Fri Oct 24 2014 tmb <tmb> 4.9.2-1.RC.2.mga5
+ Revision: 792983
- lsan is only available on x86_64
- update filelists
- update to 4.9.2-RC

* Wed Oct 15 2014 umeabot <umeabot> 4.9.2-0.20141001.2.mga5
+ Revision: 747981
- Second Mageia 5 Mass Rebuild

* Fri Oct 03 2014 tmb <tmb> 4.9.2-0.20141001.1.mga5
+ Revision: 736459
- update to 2014-10-01
- update to 2014-10-01

* Thu Sep 25 2014 tmb <tmb> 4.9.2-0.20140924.1.mga5
+ Revision: 724531
- update to 2014-09-24 snapshot

* Sat Sep 20 2014 tmb <tmb> 4.9.2-0.20140910.3.mga5
+ Revision: 697479
- rebuild with fixed rpm-mageia-setup

* Tue Sep 16 2014 umeabot <umeabot> 4.9.2-0.20140910.2.mga5
+ Revision: 679433
- Mageia 5 Mass Rebuild

* Thu Sep 11 2014 tmb <tmb> 4.9.2-0.20140910.1.mga5
+ Revision: 674668
- update to 2014-09-10

* Tue Sep 09 2014 tmb <tmb> 4.9.2-0.20140903.2.mga5
+ Revision: 674222
- rebuild with new glibc

* Thu Sep 04 2014 tmb <tmb> 4.9.2-0.20140903.1.mga5
+ Revision: 672114
- update to 2014-09-03

* Thu Aug 28 2014 tmb <tmb> 4.9.2-0.20140827.1.mga5
+ Revision: 669062
- update to 2014-08-27 snapshot

* Mon Aug 25 2014 tmb <tmb> 4.9.2-0.20140820.1.mga5
+ Revision: 667297
- update to 2014-08-20 snapshot

* Sat Aug 09 2014 tv <tv> 4.9.2-0.20140730.3.mga5
+ Revision: 661306
- make lib*san-devel requires lib*san1

* Sat Aug 09 2014 tv <tv> 4.9.2-0.20140730.2.mga5
+ Revision: 661283
- make libasan-devel requires libasan1

* Thu Jul 31 2014 tmb <tmb> 4.9.2-0.20140730.1.mga5
+ Revision: 658546
- update to 4.9.2 snapshot 2014-07-30 (CVE-2014-5044)

* Sun Jul 27 2014 tmb <tmb> 4.9.1-2.mga5
+ Revision: 657566
- gcc/PR61801: fix sched2 miscompiles syscall sequence

* Thu Jul 17 2014 tv <tv> 4.9.1-1.mga5
+ Revision: 653378
- new release

* Thu Jul 03 2014 tmb <tmb> 4.9.1-0.20140702.1.mga5
+ Revision: 642672
- update to 20140702 snapshot

* Tue Jul 01 2014 tmb <tmb> 4.9.1-0.20140625.2.mga5
+ Revision: 641812
- ship cxxabi.h and cxxabi_tweaks.h in both upstream default path for clang
  to work and Mageia specific path to keep backward compatibility (mga#13543)

* Thu Jun 26 2014 tmb <tmb> 4.9.1-0.20140625.1.mga5
+ Revision: 639753
- update to 20140625 snapshot

* Thu Jun 19 2014 tmb <tmb> 4.9.1-0.20140618.1.mga5
+ Revision: 638133
- update to 20140618 snapshot

* Thu Jun 12 2014 tmb <tmb> 4.9.1-0.20140611.1.mga5
+ Revision: 635741
- update to 20140611 snapshot

* Thu Jun 05 2014 tmb <tmb> 4.9.1-0.20140604.1.mga5
+ Revision: 633483
- update to 2014-06-04 snapshot

* Sat May 31 2014 pterjan <pterjan> 4.9.1-0.20140528.2.mga5
+ Revision: 628208
- Rebuild for new Python

* Thu May 29 2014 tmb <tmb> 4.9.1-0.20140528.1.mga5
+ Revision: 627475
- update to 20140528 snapshot

* Thu May 22 2014 tmb <tmb> 4.9.1-0.20140521.1.mga5
+ Revision: 624927
- update to 20140521 snapshot

* Fri May 16 2014 tmb <tmb> 4.9.1-0.20140514.1.mga5
+ Revision: 622989
- update to 20140514 snapshot

* Tue May 13 2014 tmb <tmb> 4.9.1-0.20140507.2.mga5
+ Revision: 622491
- push to release

* Thu May 08 2014 tmb <tmb> 4.9.1-0.20140507.1.mga5
+ Revision: 621215
- update to 20140507 snapshot

* Wed May 07 2014 tmb <tmb> 4.9.1-0.20140430.3.mga5
+ Revision: 621039
- switch to 4.9.1 snapshot 20140430
- fix libgcj pkconfig file
- adjust build defines
- revert PR bootstrap/56714 as it breaks the build
- drop p120 (merged), p125 (fixed)
- update filelists
- libatomic minor is now 1
- libgcj major is now 15
- libasan major is now 1
- libstdc++ micro version is now 20
- add new package definitions:
  * liblsan: Leak Sanitizer Libraries
  * libubsan: Undefined Behaviour Sanitizer Libraries
  * libvtv: Virtual Table Verification Libraries
  * libcilkrts: Cilk+ Runtime Libraries
- mudflap run time checker has been removed
- update to 4.9.0

* Mon Feb 17 2014 tmb <tmb> 4.8.2-5.mga5
+ Revision: 593942
- rebuild with new glibc

* Sat Feb 08 2014 tmb <tmb> 4.8.2-4.mga5
+ Revision: 586837
- adapt for new freetype2 include path (P125)
- test build with new glibc

* Wed Oct 23 2013 tmb <tmb> 4.8.2-3.mga4
+ Revision: 546668
- fix bug in nth_element (PR libstdc++/58800, mga #11516)

* Tue Oct 22 2013 umeabot <umeabot> 4.8.2-2.mga4
+ Revision: 545598
- Mageia 4 Mass Rebuild

* Wed Oct 16 2013 tmb <tmb> 4.8.2-1.mga4
+ Revision: 501462
- update to 4.8.2 final

* Sat Oct 12 2013 tmb <tmb> 4.8.2-0.20131009.2.mga4
+ Revision: 496063
- rebuild with new binutils & make

* Fri Oct 11 2013 tmb <tmb> 4.8.2-0.20131009.1.mga4
+ Revision: 495122
- update to 4.8.2 RC

* Fri Oct 04 2013 tmb <tmb> 4.8.2-0.20131003.1.mga4
+ Revision: 491582
- update filelists
- update to 2013-10-03

* Sun Sep 22 2013 tmb <tmb> 4.8.2-0.20130919.1.mga4
+ Revision: 483258
- update to 2013-09-19

* Tue Sep 17 2013 tmb <tmb> 4.8.2-0.20130912.1.mga4
+ Revision: 480784
- update to 2013-09-12

* Tue Sep 10 2013 tmb <tmb> 4.8.2-0.20130905.1.mga4
+ Revision: 477216
- update to 2013-09-05

* Sat Aug 24 2013 tmb <tmb> 4.8.2-0.20130822.1.mga4
+ Revision: 471381
- update to 2013-08-22 snapshot

* Sun Aug 18 2013 tmb <tmb> 4.8.2-0.20130815.1.mga4
+ Revision: 467526
- update to 2013-08-15 snapshot

* Sun Aug 11 2013 tmb <tmb> 4.8.2-0.20130808.2.mga4
+ Revision: 465377
- push to /release

* Fri Aug 09 2013 tmb <tmb> 4.8.2-0.20130808.1.mga4
+ Revision: 465008
- update to 2013-08-08

* Sat Aug 03 2013 tmb <tmb> 4.8.2-0.20130801.1.mga4
+ Revision: 463026
- update to 2013-08-01 snapshot
- force binutils 2.23.2 (build)requires

* Thu Aug 01 2013 tmb <tmb> 4.8.2-0.20130725.1.mga4
+ Revision: 461959
- update filelists
- add libatomic, libasan and libtsan (and their devel) subpackages
- libstdc++ minor is now 18
- libgcj major is now 14
- rediff gnuhash patches
- drop 'PR tree-optimization/33763' fix (merged)
- rediff linux32 patch
- drop merged patches
- update to 4.8.2 (20130725 pre-release)

* Sat May 04 2013 anssi <anssi> 4.7.2-7.mga3
+ Revision: 412285
- fix /usr/lib/cpp target (cosmetic, not seen due to alternatives)
- add conflicts against old gcc3.3-cpp for smooth upgrade

* Fri Jan 11 2013 umeabot <umeabot> 4.7.2-6.mga3
+ Revision: 351094
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jan 01 2013 tmb <tmb> 4.7.2-5.mga3
+ Revision: 337399
- rebuild for new glibc

* Wed Oct 24 2012 blino <blino> 4.7.2-4.mga3
+ Revision: 309834
- remove ar/ranlib hack now that a fixed gcc-ar is available

* Wed Oct 24 2012 blino <blino> 4.7.2-3.mga3
+ Revision: 309752
- build temporarily with AR=ar and RANLIB=ranlib to workaround broken i586-mageia-linux-gnu-ar/ranlib
- fix gcc-ar exit code (from upstream git, to fix gcc build)
- fix inlining failure with fpmath=sse pragma (gcc#54988)

* Sun Oct 07 2012 tmb <tmb> 4.7.2-2.mga3
+ Revision: 303207
- fix gcc-ar, gcc-nm and gcc-ranlib target_platform specific symlinks
  (reported by Liutauras Adomaitis on -dev ml, and in mga #7393)
- make gcc-ar, gcc-nm, and gcc-ranlib use update-alternatives like gcc

* Sun Sep 23 2012 tmb <tmb> 4.7.2-1.mga3
+ Revision: 296791
- drop patches P108, P220-P223 (merged upstream)
- update to 4.7.2

* Sun Jul 29 2012 guillomovitch <guillomovitch> 4.7.1-7.mga3
+ Revision: 275547
- drop gnatmake completion, a more uptodate one is available in bash-completion package
- fix /lib/cpp link broken by /usr move

* Fri Jul 20 2012 tmb <tmb> 4.7.1-6.mga3
+ Revision: 272720
- PR 52908 - xop-mul-1:f9 miscompiled on bulldozer (-mxop) (P220)
- PR debug/53682 * cselib.c (promote_debug_loc): Don't crash
  on NULL argument. (P221)
- PR target/53759 (sse_loadlps): Use x m x constraints in
  the vmovlps load alternative. (P222)
- mksysinfo.sh: Fix handling of glibc 2.16 bits/resource.h (P223)

* Wed Jul 18 2012 tmb <tmb> 4.7.1-5.mga3
+ Revision: 272346
- rebuild for new glibc

* Wed Jul 18 2012 colin <colin> 4.7.1-4.mga3
+ Revision: 272255
- Exclude a file on x86_64 that will conflict with usrmerge (it will be recreated after install via ldconfig anyway)

* Sat Jul 14 2012 tmb <tmb> 4.7.1-3.mga3
+ Revision: 270744
- rebuild for missing i586 packages

* Tue Jul 10 2012 rtp <rtp> 4.7.1-2.mga3
+ Revision: 269214
- Fix file list on arm.

* Tue Jun 26 2012 tmb <tmb> 4.7.1-1.mga3
+ Revision: 264094
- BR texinfo-tex
- update filelists
- ada/gcc-interface/Makefile.in: fix missing -fPIC flag (P108, upstream)
- rediff P115, P201, P208, P211, P302, P304, P507
- add packages for GNU Transactional Memory library (libitm) support
- update libstdcxx_minor, libgcj_major and libobjc_major
- update to 4.7.1

* Mon Apr 16 2012 blino <blino> 4.6.3-2.mga2
+ Revision: 230992
- add libstdc++ html doc and man pages in new libstdc++-docs package, using Fedora spec bits
  (this also removes prebuilt libstdc++ html doc from gcc-doc)
- pass --disable-quadmath if quadmath is disabled (still not enough to make the rpm build correctly)

* Sat Mar 03 2012 tmb <tmb> 4.6.3-1.mga2
+ Revision: 217194
- drop merged patches: P140, P209
- update to 4.6.3 bugfix release (74 fixes)
- make sure gnative2ascii is in gcj-tools and not in gcc-gnat (#4618)

* Sun Feb 19 2012 tmb <tmb> 4.6.2-2.mga2
+ Revision: 211052
- add fix for PR middle-end/51077 (mga #4593)
  * tree-object-size.c (addr_object_size): Check TREE_CODE of
    MEM_REF's operand rather than code of the MEM_REF itself.
    (fixes Internal compiler error when building lesstif, mga #4492)
- fix libjava bootstrap build with glibc-2.15 (upstream PR/50888)
- make gfortran require quadmath-devel if it is built
+ rtp <rtp>
- Fix build on arm:
  * fix building with quadmath disabled by removed extra info page
  * add missing arm-specific header in the gcc-plugins package

* Mon Dec 05 2011 tmb <tmb> 4.6.2-1.mga2
+ Revision: 176905
- update filelists
- add quadmath libraries for GCC __float128 and Fortran REAL*16 support
- spec cleanup
- rediff ada so.ext patch
- drop p105 (obsolete)
- update lib major/minor
- build with '--enable-linker-build-id'
- fix doc
- fix linux32 support (patch by pcpa, from mdv)
- bump requires on ppl to 0.11.2
- rediff P107, P115, P116, P132, P211, P304, P507 to apply cleanly
- drop merged patches P508-P517
- remove obsolete defattr
- drop support for ppc(64), sparc(64)
- update to 4.6.2

* Sun Sep 11 2011 fwang <fwang> 4.5.2-5.mga2
+ Revision: 142272
- rebuild for new libpng

* Wed Apr 20 2011 rtp <rtp> 4.5.2-4.mga1
+ Revision: 89091
- Add missing link in gcc-gnat (#833)
- Add fix for PR/48090
- cross gcc build fixes:
  - fix cross program prefix to be the same as for the other toolchain tools
  - fix when cross building 32 bit target on 64bit

* Tue Mar 29 2011 rtp <rtp> 4.5.2-3.mga1
+ Revision: 78682
- enable back checks
- cross toolchain fixes. Now, it should be possible to try to build cross
  toolchains (brieftly tested with mipsel cross toolchain on arm).
- disable libffi package so as to make sure newer libffi is used (which is
  the case in fact)
- fix monolithic build due to misplacement of gcc-plugin files.
- add noarch for pdf doc rpm.
- arm support (default DT_GNU_HASH, set __ARM_PCS or __ARM_PCS_VFP, fix
  wformat error)
- mips o32/n32/64 support
- backport PR/21803, PR/47166, PR/44768, PR/46865, workaround for PR/48090

* Tue Jan 18 2011 tmb <tmb> 4.5.2-2.mga1
+ Revision: 23432
- obsolete manbo-mandriva-files-gcc-* for a clean upgrade
- drop rpm tags
- drop manbo support
- drop support for old mandriva releases
- rename mandriva to mageia
- fix bugzilla url
- imported package gcc


* Sat Jan  8 2011 Thomas Backlund <tmb@mageia.org> 4.5.2-2.mga1
- initial import
- switch from manbo_mkrel to mkrel

* Tue Dec 28 2010 pcpa <pcpa> 4.5.2-1mnb2
+ Revision: 625688
- Update to gcc 4.5.2.

  + tv <tv>
    - let the doc subpackage be noarch

* Wed Aug 25 2010 cfergeau <cfergeau> 4.5.1-1mnb2
+ Revision: 573098
- gcc 4.5.1

* Tue Aug 24 2010 cfergeau <cfergeau> 4.5.0-1mnb2
+ Revision: 572931
- fix gcc-plugins group
- revert previous commit which was bogus :-/
- libstdc++ gdb python helper is always in /usr/lib whatever the arch is,
  and since it's a python script, it's "noarch", so we can unconditionnally
  put it in a directory ending in /usr/lib, no need to have both /usr/lib
  and /usr/lib64
- make sure LTO is enabled
- remove workaround for debugedit issue since it's now fixed in rpm thanks to Anssi :)
- import gcc 4.5.0

  + herton <herton>
    - Move gdb.py to gdb data dir.

* Tue Feb 09 2010 fwang <fwang> 4.4.3-2mnb2
+ Revision: 502641
- rebuild for new gmp

* Sun Jan 24 2010 fwang <fwang> 4.4.3-1mnb2
+ Revision: 495383
- New version 4.4.3
- CVE-2009-3736 patch merged upstream

  + peroyvind <peroyvind>
    - set interpreter path when using -muclibc to the one used by our uClibc (P304)

* Mon Nov 30 2009 oden <oden> 4.4.2-5mnb2
+ Revision: 471759
- P303: security fix for CVE-2009-3736

* Fri Nov 27 2009 cfergeau <cfergeau> 4.4.2-4mnb2
+ Revision: 470667
- update for gcc 4.4.2

  + tv <tv>
    - split checks in %%check
    - more more doc from libstdc++-devel and gcc-c++ into gcc-doc
    - use ln instead of cp (less disk usage, faster)

* Tue Sep 29 2009 cfergeau <cfergeau> 4.4.1-3mnb2
+ Revision: 450840
- another attempt at fixing the libgcj_bc stuff.
  The previous change wasn't a good idea because non-system compilers' libgcj_bc
  would obsolete the system libgcj_bc which is a bad idea :)

* Mon Sep 28 2009 cfergeau <cfergeau> 4.4.1-2mnb2
+ Revision: 450607
- One more attempt at fixing libgcj_bc packaging
- don't ship libgcj_bc shared libs both in libgcj10 and libgcj_bc1
  should fix bug #54121

* Thu Jul 23 2009 cfergeau <cfergeau> 4.4.1-1mnb2
+ Revision: 398776
- upload gcc 4.4.1 tarball
- preparation for gcc 4.4.1 (couldn't find it on the mirrors yet)

* Mon Jul 20 2009 anssi <anssi> 4.4.0-5mnb2
+ Revision: 398069
- remove python files from gcj-tools that conflicted with
  java-1.5.0-gcj-devel

* Sat Jul 18 2009 anssi <anssi> 4.4.0-4mnb2
+ Revision: 396976
- enable libobjc_gc (Mika Laitio)

* Wed Jun 03 2009 cfergeau <cfergeau> 4.4.0-3mnb2
+ Revision: 382395
- enable cloog/ppl in the build
- Don't install aot-compile and rebuild-gcj-db since it's part of java-1.5.0-gcj
- remove meaningless comment, disable -Wformat=error :-/
- only do try find locale files for libstdc++ if we actually build it
- check if files are present before trying to sanitize their rpath
- ada fixes
- Revert wrong hunk from wformat-fixes (see comment above it in the source)

* Tue May 19 2009 cfergeau <cfergeau> 4.4.0-1mnb2
+ Revision: 377476
- Don't attempt to build ada docs when ada is disabled
- Add cloog/ppl support to build (disabled for now)
- Fix customization of gcc bug URL
- Fix spec for ada support. Don't reenable ada build for now since we don't have
  a gnat compiler available in main to bootstrap it
- enable java in build
- spec update for gcj 4.4.0
- Initial pass at a gcc 4.4 package, rediff patches and get working C and C++ compilers. java and ada and tests are disabled for now.
- Fix one more format warning
- Get rid of cputoolize
- Rediff patches against gcc 4.3.3
- Reset release counter
- Disable ada for now
- Add missing space in substitution, this bug has been here forever, dunno why it never showed up before...
- Add patch 114 to fix -Wformat=error issues
- Upload gcc 4.3.3 tarball

  + helio <helio>
    - Add another wformat fix on current patch

  + anssi <anssi>
    - split libgcj_bc to a separate package to avoid future conflicts
    - fix libgcj_bc handling of non-system-compilers (ported from gcc4.3)
    - do not require libgcj-devel in gcj-tools

  + peroyvind <peroyvind>
    - only leave out libgcc_eh.a when building cross bootstrap (needs to be verified)
    - don't include libgomp.info when building without libgomp
    - libgmp-devel & libmpfr-devel is needed for building regardless of gfortran
    - sync some patches and configure options with gcc from gdium tree
    - fix bootstrap build of cross compiler
    - work around issue with xgcc ignoring --sysroot when cross-compiling
    - fix so that lsb-headers patches gets applied in correct location..
    - * add mips stuff to lsb-headers for cross compiling (P1000)
      * sysroot headers should go to usr/include/, not include/

  + pixel <pixel>
    - rebuild with gnat enabled

* Fri Nov 07 2008 pixel <pixel> 4.3.2-5mnb2
+ Revision: 300457
- rebuild without gnat for now (we need to rebuild libgcj first)

  + tv <tv>
    - rebuild since lib{,64}gcj9 depends on libxcb-xlib.so.0 which is no more

* Fri Sep 12 2008 pixel <pixel> 4.3.2-3mnb2
+ Revision: 284163
- fix broken symlinks <platform>-gfortran and <platform>-gcj (#43341)
- when not system_compiler:
  o handle conflicts with system_compiler
  o require manbo-files-gcc%%{branch}

* Thu Sep 04 2008 pixel <pixel> 4.3.2-2mnb2
+ Revision: 280693
- rename libffi-devel back to libffi4-devel (cf #43381)

* Fri Aug 29 2008 pixel <pixel> 4.3.2-1mnb2
+ Revision: 277302
- 4.3.2
- drop db-pathtail patch (fixed upstream)
- fix build when not system_compiler
- fix build without libgomp

* Fri Jun 27 2008 pixel <pixel> 4.3.1-2mnb2
+ Revision: 229470
- snapshot 4.3-20080626 (including fix for gccbz#36533)
- do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Mon Jun 09 2008 pixel <pixel> 4.3.1-1mnb2
+ Revision: 217093
- gcc 4.3.1
- workaround bug with redefined extern inline (mdvbz #41171, upstream #33763)
- drop alternatives for anything but c,c++,cpp
- so drop having %%version in binary names (eg: gjar instead of gjar-4.3.1),
  this implies gcj-tools conflicts with current classpath
- libgcj-devel and libgcj-static-devel must obsolete libgcj9-devel and libgcj9-static-devel

* Mon May 19 2008 pixel <pixel> 4.3.1-0.20080515mnb2
+ Revision: 208957
- snapshot 4.3-20080515
- change version in java homedir to 1.5.0
- drop logging.properties and classpath.security (bug #23693)
- load java property files from /usr/lib instead of /usr/lib64 on 64-bit
  systems (patch130, see bug #23693)
- add patch133 (db-pathtail) to fix build (??, from gcc4.3.spec)
- drop patch 104 for now, may break cross builds
  (but hopefully it can be fixed differently)
- drop old patch 117, hopefully unneeded (Ada only)
- drop now unneeded patches 118, 120, 121, 123, 125, 128
- rediff patches 202, 211
- libgcj9 conflicts with libgcj8
- gcc-java now requires eclipse-ecj
- drop require for zip from libgcj-devel, gjar is now used
- drop patch 104 for now, may break cross builds
  (but hopefully it can be fixed differently)
- be the system_compiler on mdv2009.0
- add support for building on distros where gcc4.2 is system_compiler
- libxxx-devel which have files in %%{gcc_libdir}/%%{gcc_target_platform}/%%{version} and do not require gcc must own that directory
- %%{gcc_libdir}/%%{gcc_target_platform}/%%{version}/include/bits must be owned by libstdc++-devel
  (otherwise it's not removed on upgrade to a new gcc version)
- build libffi when building java, but remove the binaries in non-system-compiler builds
- handle build_stdcxxheaders on non system_compiler (from gcc4.3.spec)
- drop support for building on mdv2007.0 and older
- drop mention of deprecated gcc-$(gcc%%{branch}-version) for non system_compiler from %%description
- use %%{buildroot} instead of $RPM_BUILD_ROOT
- handle building without libgcj_bc, and build with libgcj_bc and not system_compiler (from gcc4.3.spec)

* Mon Mar 17 2008 pixel <pixel> 4.2.3-6mnb1
+ Revision: 188307
- add requires on specific manbo-files-gcc-xxx

* Fri Mar 14 2008 pixel <pixel> 4.2.3-5mnb1
+ Revision: 187793
- increase release
- gcc can't use %%check since we need to "make check" before %%install. but still
  allow "--without check" the standard way
- %%{base_release} is not needed anymore
- revert gcc-core/gcc-other split
- re-add Requires on manbo-files-gcc
  (no Requires(pre) needed since all files are not installed through the symlink)
- revert gcc-core/gcc-other split (only keeping the fixes and manbo_mkrel)
- revert gcc-core/gcc-other split
- use manbo_mkrel for gcc-core
- we must ensure manbo-files-gcc is installed prior to install of files in
  /usr/lib/gcc/*-mandriva-linux-gnu/<version>/ (otherwise manbo-files-gcc
  install will fail)

* Wed Mar 12 2008 pixel <pixel> 4.2.3-3mdv2008.1
+ Revision: 187140
- use simple "make bootstrap-lean" instead of "make profiledbootstrap"
  (it fails, it is not very useful, and jakub disabled it in fedora too)
- libjack-devel is needed to build libgjsmdssi
- java: always build with dssi-devel for libgjsmdssi

* Fri Mar 07 2008 pixel <pixel> 4.2.3-2mdv2008.1
+ Revision: 181288
- fix build on x86_64: do not create 32/libgomp.so if not build_libgomp
- add script to sync gcc-other from gcc-core
- new release: 4.2.3
- use a fixed list of include headers to keep

  + knaka <knaka>
    - use _real_vendor not _vendor
    - gcc requires gcc-manbo-files if the vendor is "manbo"
    - fix vendor name as "manbo"
    - fix a condition macro
    - added prereq for "manbo-files-gcc"
    - remove requirement for manbo-files
    - modify misc packages require not gcc but gcc-BRANCH
    - split the SRPM to "core" and "other" for Manbo packages
    - Rename the spec file
    - Renamed from "gcc" for Manbo packages

  + tv <tv>
    - rebuild
    - kill re-definition of %%buildroot on Pixel's request
    - move huge (& mostly prehistoric) Changelogs in doc subpackage

  + blino <blino>
    - restore BuildRoot

* Thu Dec 06 2007 pixel <pixel> 4.2.2-2mdv2008.1
+ Revision: 115817
- new 4.2.x snapshot (includes fix for PR34130, ie -10*abs(...) => abs(10*...))

* Tue Nov 13 2007 pixel <pixel> 4.2.2-1mdv2008.1
+ Revision: 108502
- 4.2.2 final release

  + tv <tv>
    - s/Mandrake/Mandriva/

* Fri Sep 14 2007 pixel <pixel> 4.2.2-0.RC.1mdv2008.0
+ Revision: 85687
- 4.2.2 RC1

* Tue Aug 28 2007 pixel <pixel> 4.2.1-6mdv2008.0
+ Revision: 72838
- new svn snapshot
- get rid of one last hardlink (c++-%%{version} and g++-%%{version}) by simplifying some script
- fix build without fortran/java/c++

  + tv <tv>
    - kill update-alternative file require
    - kill file require on info-install

  + spturtle <spturtle>
    - for ppc, remove ssp options from OPT_FLAGS because libgcj crashes when built with them

* Fri Aug 03 2007 pixel <pixel> 4.2.1-4mdv2008.0
+ Revision: 58669
- replace hardlinks on binaries with symlinks (#18160)
- don't mess with binaries gcc-%%{version} and %%{gcc_target_platform}-gcc (#18160)
  so that they are correctly the same file (hardlinks)
- do package binary %%{gcc_target_platform}-gcc-%%{version}
- do not package /usr/bin/gcj (as used to be in 4.1 pkg), otherwise alternatives are broken
  (nb: it breaks cooker to cooker upgrade, please fix by hand)
- new svn snapshot from 4.2 branch
- drop applied gcc-ada-gnat_ugn-info-fix.patch
- normalize %%clean (#18155)
  (maybe it was used by gb to keep test_summary.log, this is no longer needed)
- add -%%{version} suffix to gkeytool to avoid conflict with classpath

  + anssi <anssi>
    - disable libgcj_bc.so.1 provides from the libgcj-devel package, only
      libgcj8 itself should provide it

* Fri Jul 06 2007 pixel <pixel> 4.2.1-3mdv2008.0
+ Revision: 48942
- get rid of colorgcc (it will be in its own package)
- libstdc++.mo files from libstdc++ to gcc-c++ (to respect proper libification)
- don't package /usr/lib/gcj-4.2.1/*.la files
- add -%%{version} suffix to gappletviewer/gjarsigner to avoid conflict with classpath
- libstdc++-static-devel doesn't conflict with other libstdc++X-static-devel pkgs
- libgcj-devel doesn't conflict with other libgcjX-devel pkgs
- libgcj-static-devel doesn't conflict with other libgcjX-static-devel pkgs
- libstdc++-devel doesn't conflict with other libstdc++X-devel pkgs
- add obsolete/provide from libstdc++-static-devel on libstdc++6-static-devel
- fix obsolete from libffi-devel (it is now on libffi4-devel), and add provide
- add provides on obsoleted libstdc++6-devel (#31765)

* Thu Jul 05 2007 pixel <pixel> 4.2.1-2mdv2008.0
+ Revision: 48664
- 4.2.1 RC1
- use libxxx-devel instead of libxxx1-devel for libstdc++-devel, libgcj-devel,
  libffi-devel, libmudflap-devel, libssp-devel, libgomp-devel
- simplify conflicts on previous devel packages
- drop biarch_java support from .spec (it was already disabled)
- have the test_summary.log in the right place
- fix gcj_libdir (it is in lib64 on x86_64)
- use %%{gcj_libdir} macro, and drop the duplicated %%{gcj_libdir} entry
- we currently can't have a nice fixed list of *.h not to bundle, so don't die
  when removing non existing *.h
- zip is required to build libjava
- 4.2.0 svn snapshot
- drop libgcjawt renaming (still needed? maybe not since it has moved)
- package the result of tests to allow comparing when building a new gcc
- package libstdc++.mo files
- move branch to mainstream
- replacing with branch version

  + anssi <anssi>
    - remove classpath.security and logging.properties as they now reside in
      jpackage-utils (fixes bug #23693)
    - add biarch handling for libgcj-tools and libgcj_bc

  + spturtle <spturtle>
    - do not try to build the spu cross compiler on ppc
    - do not build soft-float libraries for ppc

  + peroyvind <peroyvind>
    - actually disable libffi when defining so (fixes #26518)
    - add autogen to buildrequires for %%check (fixes #17409)
    - add niagara support (P1000 & P1001, fixes #28503)
    - Fix %%g7 usage in TLS, add patch sparc-g7.dpatch, fixes glibc-2.4 build failure
      on sparc (Fabio M. Di Nitto) (P1000)


* Fri Mar 02 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.1.2-1mdv2007.0
+ Revision: 131425
- don't build crt files with -fasynchronous-unwind-tables
- 4.1.2 + SVN (2007/03/02):
  * fix C++ visibility regression
  * fix PRs c++/30536, ada/30684, fortran/29441, fortran/25392,
  fortran/30400, fortran/30799, fortran/30478, rtl-optimization/30931,
  rtl-optimization/29599, middle-end/24427, rtl-optimization/28173,
  tree-optimization/30823, rtl-optimization/30787, debug/30189,
  rtl-optimization/28772, middle-end/30473, middle-end/30313
- fix full cross-compilers (e.g. {ppc,ppc64} on x86_64 for C, C++, Fortran 95)

* Mon Jan 15 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.1.2-0.20070115.1mdv2007.1
+ Revision: 109050
- 4.1-branch (2007/01/15)
- don't package nof libraries on ppc
- fix default --with-cpu for non-ppc32e arches
- default to --hash-style=gnu
- add MNI intrinsics support (SSSE3)
- fix sse3 monitor intrinsic on x86_64 (PR target/24879)
- Created directory for version 4.1.2.
- Created releases directory.

* Wed Jan 10 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.1.2-0.20061110.2mdv2007.1
+ Revision: 106916
- backport Cell SPU support from trunk
- fix build with new optflags

* Fri Nov 10 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.1.2-0.20061110.1mdv
- 4.1-branch (2006/11/10)
- slight updates to the Cell patch
- optimize for power4+ processors on ppc64
- add arm support files on popular request
- move classmap.db to arch-dependent library package, not gcj-tools
- fix ia64 cross compiler build (import LSB 3.1 headers)
- fix buildrequires, crosscompiler builds (#26715, #26483, #26484, #26518)
- enable long-double-128 on sparc (Per Oyvind Karlsen, #26485)

* Fri Oct 13 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.1.2-0.20060921.1mdv
- 4.1-branch (2006/09/21)
- merge Cell PPU optimizer from SCEI / BSC (IBM SDK 1.1)

* Tue Jul 25 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.1.1-3mdk
- handle gfortran in colorgcc (#20265)
- enable 128-bit long doubles on powerpc arches (Jakub, RH 4.1-branch)
- 4.1-branch (2006/07/24)
  * fix PRs c++/27495 c++/28025 c++/28048 c++/28235 c++/28258
    c++/28291 c++/28304 c++/28337 c++/28338 c++/28363 c/26993 c/28286
    middle-end/28283 target/28247 tree-optimization/19505

* Wed Jul 19 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.1.1-2mdk
- 4.1-branch (2006/07/16)
- add -mtune=generic (trunk)
- drop jdk-config (use pkg-config)
- fix colorgcc alternatives on upgrades
- fix build without java (Per Oyvind Karlsen)

* Fri May 19 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.1.1-1mdk
- 4.1.1 RC1
- rebuild against glibc 2.4 (stop building libssp0)
- add missing obsoletes (libgfortran0, libgcj6-base, libgcj6-src)

* Fri Apr 07 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.1.1-0.20060405.1mdk
- buildrequires alsa devel deps
- 4.1-branch (2006/04/05):
  * fix PRs java/26858, java/26858, java/2604, fortran/25358,
    fortran/19303, tree-optimization/26996, tree-optimization/26763,
    tree-optimization/18527, tree-optimization/26830, target/26459,
    libfortran/26735, fortran/19303, libgcj/26625, libgcj/27024,
    libgcj/26990, java/25414, java/26042

* Sat Apr 01 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.1.1-0.20060328.1mdk
- 4.1-branch (2006/03/28), major 4.1 changes include:
  * add new C parser
  * add Objective-C++ language support
  * vastly improve Java support (Classpath 0.19 + 0.20 bug fixes)
  * clean rewrite of stack-smashing protector

* Wed Mar 15 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.3-1mdk
- build libffi with PIC, decide later whether to ship DSO or not
- 4.0.3 release, fix a few more PRs: c/25682, c++/26291, c++/26266,
  ada/25885, ada/20753, middle-end/18859, target/23706, target/22553,
  middle-end/26092, c++/25632, ada/13408, rtl-optimization/25196,
  middle-end/16045, target/26255, bootstrap/16787, libgcj/26351,

* Sun Feb 19 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.3-0.20060215.2mdk
- fix biarch ppc64 build (missing -m32 crt files)
- add libffi & java support to sparc arches (Per Oyvind)
- add option to tune for Montecito CPUs (alias to Itanium 2 for now, H.J. Lu)

* Wed Feb 15 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.3-0.20060215.1mdk
- 4.0.2 + SVN 4.0-branch (2006/02/15)
- fix <ffitarget.h> include (#19564)
- remove lib-gnu-java-awt-peer-gtk.la, nobody lt_dlopens it (#20462)

* Thu Nov 03 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.2-1mdk
- 4.0.2 + SVN 4.0-branch (2005/11/03)
- fix build as secondary compiler on MDK 10.0
- fix E: gcj-tools binary-or-shlib-defines-rpath

* Fri Sep 16 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.1-6mdk
- fix requires and conflicts for updates

* Fri Sep 02 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.1-5mdk
- merge libjava from 4.0-rhl-branch
- make gcjh generate arch-independent code for 0x80000000
- add fastjar and grepjar man pages
- don't move <gcj/libgcj-config.h> around
- stick to /usr/share/java-ext dir for jpackage existing practise
- remove duplicated files, create a libgcjX-base package for classes
- fix possible reloads into read-only memory (4.0-branch, PR rtl-opt/15248)

* Tue Aug 30 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.1-4mdk
- build the cairo Graphics2D implementation on GTK (backport from 4.1)
- ship with biarch c++config.h headers
- mklibnamize java libs package, aka don't depend on huge 32-bit runtime
- fix kopete miscompilation on x86_64 (Richard Guenther, PR tree-opt/23326)
- merge from RH 4.0.1-10:
  * more testcases
  * support more than 16 nested GCC visibility pragmas (H.J.Lu)
  * fix linker command line ordering when compiling multiple java
    source files (Tom Tromey, #163099)
  * diagnose invalid uses of inline (Eric Christopher, PRs c/22052, c/21975)
  * fix __builtin_*_chk miscompilation (PR middle-end/23484)
- merge some java related changes from David Walluck:
  * add missing java files
  * don't add gcj- prefix to tools
  * java-1.4.2-gcj-compat now handles java and javac wrappers
  * fix libgcj alternative removal
  * ship with Java runtime library sources for use in Eclipse
  * ship with libgcjawt instead of jawt commonly used in non-free JVMs

* Sat Aug 27 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.1-3mdk
- updates from 4.0-branch (2005/08/26):
  * fix -dv option handling
  * fix documentation for -ftree-dominator-opts
  * fix PRs rtl-opt/23560, tree-optimization/23546, middle-end/23517,
    target/21571, target/23070, c/18175, middle-end/20624, c/21562,
    rtl-opt/21254, c++/23337, tree-optimization/21105, rtl-opt/23299,
    middle-end/23369, middle-end/23312, middle-end/22439,
    rtl-opt/23241, middle-end/21894, middle-end/21728,
    middle-end/21529, middle-end/21291, c++/20817, c++/22454,
    c++/23044, tree-optimization/23426, c++/22233, c++/23089,
    c++/21799, c++/8271, c++/23266, c++/23219, c++/20646, c++/22508,
    c++/23191, fortran/20363, fortran/23065, fortran/21432,
    libfortran/20006, libfortran/22143, fortran/18833, fortran/20850,
    fortran/22010, java/17845, java/21436, java/23230,
    libfortran/23154, libfortran/23428, libgcj/21020, libgcj/21074,
    libgcj/23353, libstdc++/23465, libstdc++/23550

* Fri Aug 05 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.1-2mdk
- add Red Hat Fortify extensions
- updates from 4.0-branch (2005/08/04):
  * aliasing bug fixes (tree-opt/23192, tree-opt/22591)
  * fix PRs tree-opt/19899, c/22311, rtl-opt/22619, middle-end/21362,
    debug/20161, c++/22545, fortran/22503, libfortran/23178,
    fortran/22570 et al.

* Wed Jul 27 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.1-1mdk
- 4.0.1 + updates from 4.0-branch (CVS 2005/07/26)
  * Fix PRs debug/21828, target/21149, target/22576,
    rtl-optimization/22167, tree-opt/22278, target/21721,
    middle-end/22057, c/22421, middle-end/20593, tree-opt/22105,
    middle-end/22028, debug/21946, debug/21946, middle-end/17961,
    target/22083, c/21911, c/22308, c/22013, c/22098, c++/22263,
    c++/22139, c++/22204, c++/22132, c++/20637, c++/20678, c++/21903,
    c++/20789, c++/21929, c++/20746, c++/10611, c++/20563

* Tue Jun 07 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.1-0.2mdk
- 4.0.1 (CVS 2005/06/06)
- description tweaks
- buildrequires gawk >= 3.1.4
- build ada on ia64
- fix build on ppc with nof libs (Christiaan)
- fix build on ppc64 and make it a biarch compiler too (3.3-branch)
- remove obsolete RH compatibility code with "2.96"

* Fri Jun 03 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.1-0.1mdk
- 4.0.1 (CVS 2005/06/01)
- obsoletes gcc-g77, improve post scriptlets
- fix internal build of ada for the testsuite
- fix build on x86_64 without biarch awt peers
- add missing MMX & 3D Now! intrinsics headers

* Thu May 05 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.0-3mdk
- rebuild as system compiler
- don't build 32-bit awt/gtk peer on lib64 platforms
- make /usr/lib/security/*.security %%config(noreplace)

* Tue May 03 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 4.0.0-2mdk
- ship with mudflap libs
- buildrequires: libgmp-devel for gfortran
- enable java with some changes:
  * add missing security and database files
  * add current directory in classpath if empty
  * handle java -jar JARFILE in the wrapper script
- updates from 4.0-branch as of 2005/05/02:
  * really inline memcpy with -minline-all-stringops (fix etherboot build)
  * fix kernel miscompilation (PR tree-optimization/21173)
  * more tweaks to <tr1/type_traits> (issue 3.20)
  * fix PRs ada/18847, c++/19542, rtl-optimization/21144,
    target/21098, java/21022, c/21159, c/21213, c/20740,
    rtl-optimization/21163, middle-end/20991, target/21101, c++/21087,
    middle-end/20991, fortran/13082, fortran/18824, fortran/16861,
    fortran/20865, fortran/21177, fortran/20879, fortran/20059,
    java/21115, java/20768, libgfortran/20950, libgcj/21136,
    libgcj/21233, libstdc++/21286, libstdc++/21244, libstdc++/21035,
    libstdc++/20914

* Wed Apr 27 2005 Gwenole Beauchesne <gbeauchesne@mandrva.com> 4.0.0-1mdk
- add missing <bits/cxxabi_tweaks.h>
- don't obsolete g77 packages as they may still be there for now
- further visibility fixes for KDE 3.4 on x86-64
- 4.0 release + updates from 4.0-branch as of 2005/04/24:
  * fix PRs rtl-opt/21102, target/21100, target/21099, c++/20805,
    middle-end/20973, c/12913, fortran/14569
- merge with gcc3.4 package:
  * fix javac wrapper script for automake1.9 testsuite (Christiaan)
  * fix libgcj pkgconfig files to look for gcj includes at the right place
  * avoid installing gcc into /usr/lib64 so that existing ways to generate
    libtool scripts can cope with 32-bit development on 64-bit platforms
  * unset TEXINPUTS when building PDF docs (G. Rousse)
  * disable 64-bit code generation if running under a 32-bit personality
  * temporarily disable libffi/java on sparc, sparc64 (Per Oyvind Karlsen)

* Fri Apr 15 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.0-0.4mdk
- add fortran 95 front-end, they are now called gfortran and f95

* Fri Apr 15 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.0-0.3mdk
- update from CVS (2005/04/14)

* Wed Dec 29 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.0-0.2mdk
- update from CVS (2004/12/28)
- make libstdc++.so symlink less sensitive to future changes from 3.4

* Sat Sep 11 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.0-0.1mdk
- Renamed to 4.0.0 (2004/09/10)

* Wed Jul 07 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.5.0-0.1mdk
- First Preview Release for Mandrakelinux

